#pragma once

#include "common.h"

enum eAudioSamples : uint32 {
	AUDIO_SAMPLE_VEHICLE_HORN_0 = 0,
	AUDIO_SAMPLE_VEHICLE_HORN_1 = 1,
	AUDIO_SAMPLE_VEHICLE_HORN_2 = 2,
	AUDIO_SAMPLE_VEHICLE_HORN_3 = 3,
	AUDIO_SAMPLE_VEHICLE_HORN_4 = 4,
	AUDIO_SAMPLE_VEHICLE_HORN_5 = 5,
	AUDIO_SAMPLE_VEHICLE_HORN_6 = 6,
	AUDIO_SAMPLE_VEHICLE_HORN_7 = 7,
	AUDIO_SAMPLE_VEHICLE_OPEN_DOOR_TYPE_1 = 8,
	AUDIO_SAMPLE_VEHICLE_CLOSE_DOOR_TYPE_1 = 9,
	AUDIO_SAMPLE_VEHICLE_OPEN_DOOR_TYPE_2 = 10,
	AUDIO_SAMPLE_VEHICLE_CLOSE_DOOR_TYPE_2 = 11,
	AUDIO_SAMPLE_VEHICLE_OPEN_DOOR_TYPE_3 = 12,
	AUDIO_SAMPLE_VEHICLE_CLOSE_DOOR_TYPE_3 = 13,
	AUDIO_SAMPLE_MODEL_VEHICLE_ACCELERATING = 14,
	AUDIO_SAMPLE_REVERSE_GEAR_ACCELERATING = 15,
	AUDIO_SAMPLE_REVERSE_GEAR_CONSTANT = 16,
	AUDIO_SAMPLE_VEHICLE_ENGINE_START = 17,
	AUDIO_SAMPLE_VEHICLE_ROAD_NOISE = 18,
	AUDIO_SAMPLE_VEHICLE_SKIDDING = 19,
	AUDIO_SAMPLE_COLLISION_LOOPING_SOFT = 20,
	AUDIO_SAMPLE_VEHICLE_SIREN = 21,
	AUDIO_SAMPLE_VEHICLE_SIREN_HORN = 22,
	AUDIO_SAMPLE_VEHICLE_AMBULANCE_SIREN = 23,
	AUDIO_SAMPLE_VEHICLE_REVERSE_WARNING = 24,
	AUDIO_SAMPLE_VEHICLE_ICE_CREAM_JINGLE = 25,
	AUDIO_SAMPLE_VEHICLE_ALARM = 26,
	AUDIO_SAMPLE_VEHICLE_AIR_BRAKES = 27,
	AUDIO_SAMPLE_28_EMPTY = 28,
	AUDIO_SAMPLE_COLLISION_RUBBER = 29,
	AUDIO_SAMPLE_TRAIN_FAR = 30,
	AUDIO_SAMPLE_TRAIN_CLOSE = 31,
	AUDIO_SAMPLE_PED_FALL_PAVEMENT_1 = 32,
	AUDIO_SAMPLE_PED_FALL_PAVEMENT_2 = 33,
	AUDIO_SAMPLE_PED_FALL_PAVEMENT_3 = 34,
	AUDIO_SAMPLE_PED_FALL_PAVEMENT_4 = 35,
	AUDIO_SAMPLE_PED_FALL_PAVEMENT_5 = 36,
	AUDIO_SAMPLE_PED_FALL_GRASS_1 = 37,
	AUDIO_SAMPLE_PED_FALL_GRASS_2 = 38,
	AUDIO_SAMPLE_PED_FALL_GRASS_3 = 39,
	AUDIO_SAMPLE_PED_FALL_GRASS_4 = 40,
	AUDIO_SAMPLE_PED_FALL_GRASS_5 = 41,
	AUDIO_SAMPLE_PED_FALL_DIRT_1 = 42,
	AUDIO_SAMPLE_PED_FALL_DIRT_2 = 43,
	AUDIO_SAMPLE_PED_FALL_DIRT_3 = 44,
	AUDIO_SAMPLE_PED_FALL_DIRT_4 = 45,
	AUDIO_SAMPLE_PED_FALL_DIRT_5 = 46,
	AUDIO_SAMPLE_PED_FALL_WOOD_1 = 47,
	AUDIO_SAMPLE_PED_FALL_WOOD_2 = 48,
	AUDIO_SAMPLE_PED_FALL_WOOD_3 = 49,
	AUDIO_SAMPLE_PED_FALL_WOOD_4 = 50,
	AUDIO_SAMPLE_PED_FALL_WOOD_5 = 51,
	AUDIO_SAMPLE_PED_FALL_METAL_1 = 52,
	AUDIO_SAMPLE_PED_FALL_METAL_2 = 53,
	AUDIO_SAMPLE_PED_FALL_METAL_3 = 54,
	AUDIO_SAMPLE_PED_FALL_METAL_4 = 55,
	AUDIO_SAMPLE_PED_FALL_METAL_5 = 56,
	AUDIO_SAMPLE_PED_FALL_IN_WATER_1 = 57,
	AUDIO_SAMPLE_PED_FALL_IN_WATER_2 = 58,
	AUDIO_SAMPLE_PED_FALL_IN_WATER_3 = 59,
	AUDIO_SAMPLE_PED_FALL_IN_WATER_4 = 60,
	AUDIO_SAMPLE_PED_FALL_SAND_1 = 61,
	AUDIO_SAMPLE_PED_FALL_SAND_2 = 62,
	AUDIO_SAMPLE_PED_FALL_SAND_3 = 63,
	AUDIO_SAMPLE_64 = 64,
	AUDIO_SAMPLE_WEAPON_GRENADE_EXPLOSION = 65,
	AUDIO_SAMPLE_WEAPON_MOLOTOV_EXPLOSION = 66,
	AUDIO_SAMPLE_WEAPON_PISTOL_SHOT = 67,
	AUDIO_SAMPLE_68 = 68,
	AUDIO_SAMPLE_WEAPON_M16_SHOT = 69,
	AUDIO_SAMPLE_70 = 70,
	AUDIO_SAMPLE_WEAPON_CHAINGUN_SHOT = 71,
	AUDIO_SAMPLE_72 = 72,
	AUDIO_SAMPLE_WEAPON_UZI_SHOT = 73,
	AUDIO_SAMPLE_74 = 74,
	AUDIO_SAMPLE_75 = 75,
	AUDIO_SAMPLE_76 = 76,
	AUDIO_SAMPLE_WEAPON_SNIPER_SHOT = 77,
	AUDIO_SAMPLE_78 = 78,
	AUDIO_SAMPLE_WEAPON_ROCKET_SHOT = 79,
	AUDIO_SAMPLE_80 = 80,
	AUDIO_SAMPLE_WEAPON_ROCKET_PROCESS = 81,
	AUDIO_SAMPLE_WEAPON_FLAMETHROWER_SHOT = 82,
	AUDIO_SAMPLE_83 = 83,
	AUDIO_SAMPLE_WEAPON_FLAMETHROWER_FIRE = 84,
	AUDIO_SAMPLE_85 = 85,
	AUDIO_SAMPLE_WEAPON_SHOTGUN_SHOT = 86,
	AUDIO_SAMPLE_87 = 87,
	AUDIO_SAMPLE_WEAPON_PISTOL_RELOAD = 88,
	AUDIO_SAMPLE_WEAPON_CHAINGUN_RELOAD = 89,
	AUDIO_SAMPLE_WEAPON_UZI_RELOAD = 90,
	AUDIO_SAMPLE_WEAPON_ROCKET_RELOAD = 91,
	AUDIO_SAMPLE_WEAPON_SNIPER_RELOAD = 92,
	AUDIO_SAMPLE_COLLISION_PAVEMENT = 93,
	AUDIO_SAMPLE_94 = 94,
	AUDIO_SAMPLE_95 = 95,
	AUDIO_SAMPLE_96 = 96,
	AUDIO_SAMPLE_97 = 97,
	AUDIO_SAMPLE_COLLISION_MUFFLED = 98,
	AUDIO_SAMPLE_COLLISION_DIRT = 99,
	AUDIO_SAMPLE_COLLISION_MUD = 100,
	AUDIO_SAMPLE_COLLISION_METAL_DOOR = 101,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_1 = 102,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_2 = 103,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_3 = 104,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_4 = 105,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_5 = 106,
	AUDIO_SAMPLE_CAR_DOOR_MOVEMENT_6 = 107,
	AUDIO_SAMPLE_COLLISION_METAL_11 = 108,
	AUDIO_SAMPLE_COLLISION_HARD = 109,
	AUDIO_SAMPLE_COLLISION_METAL_13 = 110,
	AUDIO_SAMPLE_COLLISION_METAL_14 = 111,
	AUDIO_SAMPLE_COLLISION_FENCE = 112,
	AUDIO_SAMPLE_113 = 113,
	AUDIO_SAMPLE_114 = 114,
	AUDIO_SAMPLE_115 = 115,
	AUDIO_SAMPLE_COLLISION_FLESH = 116,
	AUDIO_SAMPLE_117 = 117,
	AUDIO_SAMPLE_118 = 118,
	AUDIO_SAMPLE_119 = 119,
	AUDIO_SAMPLE_120 = 120,
	AUDIO_SAMPLE_COLLISION_SAND = 121,
	AUDIO_SAMPLE_COLLISION_WOOD = 122,
	AUDIO_SAMPLE_123 = 123,
	AUDIO_SAMPLE_124 = 124,
	AUDIO_SAMPLE_125 = 125,
	AUDIO_SAMPLE_COLLISION_WOOD_BOX = 126,
	AUDIO_SAMPLE_127 = 127,
	AUDIO_SAMPLE_128 = 128,
	AUDIO_SAMPLE_129 = 129,
	AUDIO_SAMPLE_COLLISION_WOOD_PLANK = 130,
	AUDIO_SAMPLE_COLLISION_HEDGE = 131,
	AUDIO_SAMPLE_PED_FALL_HEDGE_2 = 132,
	AUDIO_SAMPLE_PED_FALL_HEDGE_3 = 133,
	AUDIO_SAMPLE_PED_FALL_HEDGE_4 = 134,
	AUDIO_SAMPLE_PED_FALL_HEDGE_5 = 135,
	AUDIO_SAMPLE_COLLISION_METAL_27 = 136,
	AUDIO_SAMPLE_COLLISION_METAL_28 = 137,
	AUDIO_SAMPLE_138 = 138,
	AUDIO_SAMPLE_139 = 139,
	AUDIO_SAMPLE_COLLISION_METAL = 140,
	AUDIO_SAMPLE_COLLISION_CRANE = 141,
	AUDIO_SAMPLE_142 = 142,
	AUDIO_SAMPLE_143 = 143,
	AUDIO_SAMPLE_144 = 144,
	AUDIO_SAMPLE_COLLISION_LOOSE = 145,
	AUDIO_SAMPLE_146 = 146,
	AUDIO_SAMPLE_COLLISION_GATE = 147,
	AUDIO_SAMPLE_COLLISION_LOOPING_GENERIC = 148,
	AUDIO_SAMPLE_149 = 149,
	AUDIO_SAMPLE_GLASS_WINDSHIELD_CRACK = 150,
	AUDIO_SAMPLE_GLASS_GENERIC_BREAK = 151,
	AUDIO_SAMPLE_GLASS_LIGHT_BREAK_1 = 152,
	AUDIO_SAMPLE_GLASS_LIGHT_BREAK_2 = 153,
	AUDIO_SAMPLE_GLASS_LIGHT_BREAK_3 = 154,
	AUDIO_SAMPLE_GLASS_LIGHT_BREAK_4 = 155,
	AUDIO_SAMPLE_FIRE_PED = 156,
	AUDIO_SAMPLE_FIRE_ENTITY = 157,
	AUDIO_SAMPLE_COLLISION_LOOPING_GRASS = 158,
	AUDIO_SAMPLE_PICKUP_NEUTRAL_1 = 159,
	AUDIO_SAMPLE_PICKUP_NEUTRAL_2 = 160,
	AUDIO_SAMPLE_PICKUP_SUCCESS_1 = 161,
	AUDIO_SAMPLE_PICKUP_SUCCESS_2 = 162,
	AUDIO_SAMPLE_PICKUP_SUCCESS_3 = 163,
	AUDIO_SAMPLE_PICKUP_SUCCESS_4 = 164,
	AUDIO_SAMPLE_PICKUP_FAIL_1 = 165,
	AUDIO_SAMPLE_PICKUP_FAIL_2 = 166,
	AUDIO_SAMPLE_BULLET_GUNSHELL_HARD_DROP = 167,
	AUDIO_SAMPLE_BULLET_GUNSHELL_SOFT_DROP = 168,
	AUDIO_SAMPLE_BULLET_HIT_PED = 169,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_1 = 170,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_2 = 171,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_3 = 172,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_4 = 173,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_5 = 174,
	AUDIO_SAMPLE_BULLET_HIT_VEHICLE_6 = 175,
	AUDIO_SAMPLE_BULLET_HIT_GROUND_1 = 176,
	AUDIO_SAMPLE_BULLET_HIT_GROUND_2 = 177,
	AUDIO_SAMPLE_BULLET_HIT_GROUND_3 = 178,
	AUDIO_SAMPLE_PED_HIT_BY_BAT = 179,
	AUDIO_SAMPLE_180 = 180,
	AUDIO_SAMPLE_PED_HIT_1 = 181,
	AUDIO_SAMPLE_PED_HIT_2 = 182,
	AUDIO_SAMPLE_PED_HIT_3 = 183,
	AUDIO_SAMPLE_PED_HIT_4 = 184,
	AUDIO_SAMPLE_GARAGE_DOOR_PROCESS = 185,
	AUDIO_SAMPLE_CAR_BOMB_TICK = 186,
	AUDIO_SAMPLE_CAR_BOMB_ACTIVATED = 187,
	AUDIO_SAMPLE_POLICE_SCANNER_CRACKLE = 188,
	AUDIO_SAMPLE_POLICE_SCANNER_WE_GOT_1 = 189,
	AUDIO_SAMPLE_POLICE_SCANNER_WE_GOT_2 = 190,
	AUDIO_SAMPLE_POLICE_SCANNER_WE_GOT_3 = 191,
	AUDIO_SAMPLE_POLICE_SCANNER_TEN_1 = 192,
	AUDIO_SAMPLE_POLICE_SCANNER_TEN_2 = 193,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_1 = 194,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_2 = 195,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_3 = 196,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_4 = 197,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_5 = 198,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_6 = 199,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_7 = 200,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_8 = 201,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_9 = 202,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_10 = 203,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_11 = 204,
	AUDIO_SAMPLE_POLICE_SCANNER_CODE_CRIME_12 = 205,
	AUDIO_SAMPLE_POLICE_SCANNER_IN = 206,
	AUDIO_SAMPLE_POLICE_SCANNER_NORTH = 207,
	AUDIO_SAMPLE_POLICE_SCANNER_EAST = 208,
	AUDIO_SAMPLE_POLICE_SCANNER_SOUTH = 209,
	AUDIO_SAMPLE_POLICE_SCANNER_WEST = 210,
	AUDIO_SAMPLE_POLICE_SCANNER_CENTRAL = 211,
	AUDIO_SAMPLE_POLICE_SCANNER_SMALL_CRACKLE_1 = 212,
	AUDIO_SAMPLE_POLICE_SCANNER_SMALL_CRACKLE_2 = 213,
	AUDIO_SAMPLE_POLICE_SCANNER_SMALL_CRACKLE_3 = 214,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_LIBERTY_CITY = 215,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_PORTLAND = 216,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_STAUNTON = 217,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_SHORESIDE = 218,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_ROCKFORD = 219,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_FORT_STAUNTON = 220,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_ASPATRIA = 221,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_TORRINGTON = 222,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_BEDFORD_POINT = 223,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_NEWPORT = 224,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_BELLEVILLE = 225,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_LIBERTY_CAMPUS = 226,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_COCHRANE = 227,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_PIKE_CREEK = 228,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_CEDAR_GROVE = 229,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_WICHITA_GARDEN = 230,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_FRANCIS_INTNL = 231,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_CALLAHAN_POINT = 232,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_ATLANTIC_QUAYS = 233,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_PORTLAND_HARBOUR = 234,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_TRENTON = 235,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_CHINATOWN = 236,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_REDLIGHT = 237,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_HEPBURN_HEIGHTS = 238,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_ST_MARKS = 239,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_HARWOOD = 240,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_PORTLAND_BEACH = 241,
	AUDIO_SAMPLE_POLICE_SCANNER_ZONE_PORTLAND_VIEW = 242,
	AUDIO_SAMPLE_POLICE_SCANNER_SUSPECT = 243,
	AUDIO_SAMPLE_POLICE_SCANNER_LAST_SEEN = 244,
	AUDIO_SAMPLE_POLICE_SCANNER_ON_FOOT = 245,
	AUDIO_SAMPLE_POLICE_SCANNER_IN_A = 246,
	AUDIO_SAMPLE_POLICE_SCANNER_IN_AN = 247,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_BLACK = 248,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_WHITE = 249,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_BLUE = 250,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_RED = 251,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_PURPLE = 252,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_YELLOW = 253,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_GREY = 254,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_ORANGE = 255,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_GREEN = 256,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_SILVER = 257,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_DARK = 258,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_LIGHT = 259,
	AUDIO_SAMPLE_POLICE_SCANNER_COLOR_BRIGHT = 260,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_AMBULANCE = 261,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_VAN = 262,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_TRUCK = 263,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_ECONOMY = 264,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_SPORTS_CAR = 265,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_BUGGY = 266,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_TAXI = 267,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_CRUISER = 268,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_BUS = 269,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_COUPE = 270,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_FIRETRUCK = 271,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_BOAT = 272,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_PICKUP = 273,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_ICE_CREAM_TRUCK = 274,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_LIMO = 275,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_POLICE_CAR = 276,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_CONVERTIBLE = 277,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_SUBWAY_CAR = 278,
	AUDIO_SAMPLE_POLICE_SCANNER_CAR_TANK = 279,
	AUDIO_SAMPLE_HELI_FAR = 280,
	AUDIO_SAMPLE_HELI_AVERAGE = 281,
	AUDIO_SAMPLE_HELI_CLOSE = 282,
	AUDIO_SAMPLE_PAYPHONE_RINGING = 283,
	AUDIO_SAMPLE_VEHICLE_ENGINE_GENERIC = 284,
	AUDIO_SAMPLE_VEHICLE_ENGINE_PICKUPS = 285,
	AUDIO_SAMPLE_VEHICLE_ENGINE_SPORTS_1 = 286,
	AUDIO_SAMPLE_VEHICLE_ENGINE_VANS = 287,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CEDANS = 288,
	AUDIO_SAMPLE_VEHICLE_ENGINE_BIG = 289,
	AUDIO_SAMPLE_VEHICLE_ENGINE_TUNED = 290,
	AUDIO_SAMPLE_VEHICLE_ENGINE_SPORTS_2 = 291,
	AUDIO_SAMPLE_292 = 292,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_NONE = 293,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_GENERIC = 294,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_PICKUPS = 295,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_SPORTS_1 = 296,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_VANS = 297,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_CEDANS = 298,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_BIG = 299,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_TUNED = 300,
	AUDIO_SAMPLE_VEHICLE_ENGINE_IDLE_SPORTS_2 = 301,
	AUDIO_SAMPLE_302 = 302,
	AUDIO_SAMPLE_303 = 303,
	AUDIO_SAMPLE_JUMBO_FLY_SOUND = 304,
	AUDIO_SAMPLE_JUMBO_TAXI_SOUND = 305,
	AUDIO_SAMPLE_JUMBO_WHINE_SOUND = 306,
	AUDIO_SAMPLE_JUMBO_ENGINE_SOUND = 307,
	AUDIO_SAMPLE_JUMBO_RUMBLE_SOUND = 308,
	AUDIO_SAMPLE_VEHICLE_PLANE_TOUCHES_GROUND = 309,
	AUDIO_SAMPLE_BOAT_ENGINE_IDLE = 310,
	AUDIO_SAMPLE_BOAT_ENGINE = 311,
	AUDIO_SAMPLE_BOAT_IDLE = 312,
	AUDIO_SAMPLE_LOOPING_WATER = 313,
	AUDIO_SAMPLE_BOAT_SPLASH_0 = 314,
	AUDIO_SAMPLE_BOAT_SPLASH_1 = 315,
	AUDIO_SAMPLE_MOTOR = 316,
	AUDIO_SAMPLE_VEHICLE_CESNA_FAR = 317,
	AUDIO_SAMPLE_VEHICLE_CESNA_CLOSE = 318,
	AUDIO_SAMPLE_RAIN_ON_VEHICLE_1 = 319,
	AUDIO_SAMPLE_RAIN_ON_VEHICLE_2 = 320,
	AUDIO_SAMPLE_RAIN_ON_VEHICLE_3 = 321,
	AUDIO_SAMPLE_RAIN_ON_VEHICLE_4 = 322,
	AUDIO_SAMPLE_COLLISION_WATER = 323,
	AUDIO_SAMPLE_SPLATTER_1 = 324,
	AUDIO_SAMPLE_SPLATTER_2 = 325,
	AUDIO_SAMPLE_PED_HEADPHONES = 326,
	AUDIO_SAMPLE_BOX_DESTROYED_1 = 327,
	AUDIO_SAMPLE_BOX_DESTROYED_2 = 328,
	AUDIO_SAMPLE_ROCKET_NO_ZOOM = 329,
	AUDIO_SAMPLE_SNIPER_NO_ZOOM = 330,
	AUDIO_SAMPLE_VEHICLE_TURRET_ROTATE = 331,
	AUDIO_SAMPLE_CRANE_PROCESS = 332,
	AUDIO_SAMPLE_PED_FALL_COLLAPSE = 333,
	AUDIO_SAMPLE_PED_FALL_LAND = 334,
	AUDIO_SAMPLE_FRONTEND_BOMB_TICK = 335,
	AUDIO_SAMPLE_FRONTEND_CLOCK_TICK = 336,
	AUDIO_SAMPLE_FRONTEND_PART_MISSION_COMPLETED = 337,
	AUDIO_SAMPLE_FRONTEND_MENU_STARTING_1 = 338,
	AUDIO_SAMPLE_FRONTEND_MENU_STARTING_2 = 339,
	AUDIO_SAMPLE_VEHICLE_HYDRAULIC = 340,
	AUDIO_SAMPLE_VEHICLE_HYDRAULIC_EFFECT = 341,
	AUDIO_SAMPLE_VEHICLE_JERK = 342,
	AUDIO_SAMPLE_FRONTEND_GAMEPLAY_FAIL = 343,
	AUDIO_SAMPLE_FRONTEND_GAMEPLAY_SUCCESS = 344,
	AUDIO_SAMPLE_345 = 345,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_GENERIC = 346,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_GENERIC = 347,
	AUDIO_SAMPLE_348 = 348,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_PICKUPS = 349,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_PICKUPS = 350,
	AUDIO_SAMPLE_351 = 351,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_SPORTS_1 = 352,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_SPORTS_1 = 353,
	AUDIO_SAMPLE_354 = 354,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_VANS = 355,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_VANS = 356,
	AUDIO_SAMPLE_357 = 357,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_CEDANS = 358,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_CEDANS = 359,
	AUDIO_SAMPLE_360 = 360,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_BIG = 361,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_BIG = 362,
	AUDIO_SAMPLE_363 = 363,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_TUNED = 364,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_TUNED = 365,
	AUDIO_SAMPLE_366 = 366,
	AUDIO_SAMPLE_VEHICLE_ENGINE_CHANGE_GEAR_SPORTS_2 = 367,
	AUDIO_SAMPLE_VEHICLE_ENGINE_STOPPING_SPORTS_2 = 368,
	AUDIO_SAMPLE_369 = 369,
	AUDIO_SAMPLE_370 = 370,
	AUDIO_SAMPLE_371 = 371,
	AUDIO_SAMPLE_FRONTEND_MENU_COMPLETED_1 = 372,
	AUDIO_SAMPLE_FRONTEND_MENU_COMPLETED_2 = 373,
	AUDIO_SAMPLE_FRONTEND_MENU_DENIED_1 = 374,
	AUDIO_SAMPLE_FRONTEND_MENU_DENIED_2 = 375,
	AUDIO_SAMPLE_FRONTEND_MENU_SUCCESS_1 = 376,
	AUDIO_SAMPLE_FRONTEND_MENU_SUCCESS_2 = 377,
	AUDIO_SAMPLE_FRONTEND_MENU_EXIT_1 = 378,
	AUDIO_SAMPLE_FRONTEND_MENU_EXIT_2 = 379,
	AUDIO_SAMPLE_380 = 380,
	AUDIO_SAMPLE_381 = 381,
	AUDIO_SAMPLE_382 = 382,
	AUDIO_SAMPLE_FRONTEND_MENU_AUDIO_TEST_1 = 383,
	AUDIO_SAMPLE_FRONTEND_MENU_AUDIO_TEST_2 = 384,
	AUDIO_SAMPLE_FRONTEND_MENU_AUDIO_TEST_3 = 385,
	AUDIO_SAMPLE_FRONTEND_MENU_FAIL_1 = 386,
	AUDIO_SAMPLE_FRONTEND_MENU_FAIL_2 = 387,
	AUDIO_SAMPLE_388 = 388,
	AUDIO_SAMPLE_389 = 389,
	AUDIO_SAMPLE_PARTY_1 = 390,
	AUDIO_SAMPLE_PARTY_2 = 391,
	AUDIO_SAMPLE_PARTY_3 = 392,
	AUDIO_SAMPLE_PARTY_4 = 393,
	AUDIO_SAMPLE_PARTY_5 = 394,
	AUDIO_SAMPLE_PARTY_6 = 395,
	AUDIO_SAMPLE_PARTY_7 = 396,
	AUDIO_SAMPLE_PARTY_8 = 397,
	AUDIO_SAMPLE_PARTY_9 = 398,
	AUDIO_SAMPLE_PARTY_10 = 399,
	AUDIO_SAMPLE_PARTY_11 = 400,
	AUDIO_SAMPLE_PARTY_12 = 401,
	AUDIO_SAMPLE_PARTY_13 = 402,
	AUDIO_SAMPLE_STRIP_CLUB_1 = 403,
	AUDIO_SAMPLE_STRIP_CLUB_2 = 404,
	AUDIO_SAMPLE_WORK_SHOP = 405,
	AUDIO_SAMPLE_FRANKIE_PIANO = 406,
	AUDIO_SAMPLE_SAWMILL_1 = 407,
	AUDIO_SAMPLE_SAWMILL_2 = 408,
	AUDIO_SAMPLE_409 = 409,
	AUDIO_SAMPLE_LAUNDERETTE_1 = 410,
	AUDIO_SAMPLE_LAUNDERETTE_2 = 411,
	AUDIO_SAMPLE_CHINATOWN_RESTAURANT = 412,
	AUDIO_SAMPLE_CIPRIANI_RESTAURANT = 413,
	AUDIO_SAMPLE_414 = 414,
	AUDIO_SAMPLE_MARCO_BISTRO = 415,
	AUDIO_SAMPLE_AIRPORT_1 = 416,
	AUDIO_SAMPLE_AIRPORT_2 = 417,
	AUDIO_SAMPLE_AIRPORT_3 = 418,
	AUDIO_SAMPLE_AIRPORT_4 = 419,
	AUDIO_SAMPLE_SHOP_1 = 420,
	AUDIO_SAMPLE_SHOP_2 = 421,
	AUDIO_SAMPLE_SHOP_3 = 422,
	AUDIO_SAMPLE_CINEMA_1 = 423,
	AUDIO_SAMPLE_CINEMA_2 = 424,
	AUDIO_SAMPLE_CINEMA_3 = 425,
	AUDIO_SAMPLE_DOCKS = 426,
	AUDIO_SAMPLE_HOME_1 = 427,
	AUDIO_SAMPLE_HOME_2 = 428,
	AUDIO_SAMPLE_HOME_3 = 429,
	AUDIO_SAMPLE_HOME_4 = 430,
	AUDIO_SAMPLE_HOME_5 = 431,
	AUDIO_SAMPLE_PORN_CINEMA_1_BACKGROUND_1 = 432,
	AUDIO_SAMPLE_PORN_CINEMA_1_SEX_1 = 433,
	AUDIO_SAMPLE_PORN_CINEMA_1_SEX_2 = 434,
	AUDIO_SAMPLE_PORN_CINEMA_2_BACKGROUND_2 = 435,
	AUDIO_SAMPLE_PORN_CINEMA_2_SEX_1 = 436,
	AUDIO_SAMPLE_PORN_CINEMA_2_SEX_2 = 437,
	AUDIO_SAMPLE_PORN_CINEMA_3_BACKGROUND_3 = 438,
	AUDIO_SAMPLE_PORN_CINEMA_3_SEX_1 = 439,
	AUDIO_SAMPLE_PORN_CINEMA_3_SEX_2 = 440,
	AUDIO_SAMPLE_POLICE_BALL = 441,
	AUDIO_SAMPLE_BANK_ALARM = 442,
	AUDIO_SAMPLE_RAVE_INDUSTRIAL = 443,
	AUDIO_SAMPLE_RAVE_1 = 444,
	AUDIO_SAMPLE_RAVE_2 = 445,
	AUDIO_SAMPLE_RAVE_3 = 446,
	AUDIO_SAMPLE_447 = 447,
	AUDIO_SAMPLE_448 = 448,
	AUDIO_SAMPLE_449 = 449,
	AUDIO_SAMPLE_450 = 450,
	AUDIO_SAMPLE_451 = 451,
	AUDIO_SAMPLE_452 = 452,
	AUDIO_SAMPLE_453 = 453,
	AUDIO_SAMPLE_454 = 454,
	AUDIO_SAMPLE_455 = 455,
	AUDIO_SAMPLE_EXPLOSION_CAR = 456,
	AUDIO_SAMPLE_BRIDGE_WARNING = 457,
	AUDIO_SAMPLE_PAGER = 458,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_1 = 459,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_2 = 460,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_3 = 461,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_4 = 462,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_5 = 463,
	AUDIO_SAMPLE_POLICE_COP_1_ARREST_6 = 464,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_1 = 465,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_2 = 466,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_3 = 467,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_4 = 468,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_5 = 469,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_6 = 470,
	AUDIO_SAMPLE_POLICE_COP_1_PURSUIT_7 = 471,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_1 = 472,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_2 = 473,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_3 = 474,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_4 = 475,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_5 = 476,
	AUDIO_SAMPLE_POLICE_COP_2_ARREST_6 = 477,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_1 = 478,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_2 = 479,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_3 = 480,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_4 = 481,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_5 = 482,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_6 = 483,
	AUDIO_SAMPLE_POLICE_COP_2_PURSUIT_7 = 484,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_1 = 485,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_2 = 486,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_3 = 487,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_4 = 488,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_5 = 489,
	AUDIO_SAMPLE_POLICE_COP_3_ARREST_6 = 490,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_1 = 491,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_2 = 492,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_3 = 493,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_4 = 494,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_5 = 495,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_6 = 496,
	AUDIO_SAMPLE_POLICE_COP_3_PURSUIT_7 = 497,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_1 = 498,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_2 = 499,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_3 = 500,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_4 = 501,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_5 = 502,
	AUDIO_SAMPLE_POLICE_COP_4_ARREST_6 = 503,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_1 = 504,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_2 = 505,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_3 = 506,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_4 = 507,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_5 = 508,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_6 = 509,
	AUDIO_SAMPLE_POLICE_COP_4_PURSUIT_7 = 510,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_1 = 511,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_2 = 512,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_3 = 513,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_4 = 514,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_5 = 515,
	AUDIO_SAMPLE_POLICE_COP_5_ARREST_6 = 516,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_1 = 517,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_2 = 518,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_3 = 519,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_4 = 520,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_5 = 521,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_6 = 522,
	AUDIO_SAMPLE_POLICE_COP_5_PURSUIT_7 = 523,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_1 = 524,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_2 = 525,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_3 = 526,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_4 = 527,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_5 = 528,
	AUDIO_SAMPLE_POLICE_SWAT_1_PURSUIT_ARREST_6 = 529,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_1 = 530,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_2 = 531,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_3 = 532,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_4 = 533,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_5 = 534,
	AUDIO_SAMPLE_POLICE_SWAT_2_PURSUIT_ARREST_6 = 535,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_1 = 536,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_2 = 537,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_3 = 538,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_4 = 539,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_5 = 540,
	AUDIO_SAMPLE_POLICE_SWAT_3_PURSUIT_ARREST_6 = 541,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_1 = 542,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_2 = 543,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_3 = 544,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_4 = 545,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_5 = 546,
	AUDIO_SAMPLE_POLICE_SWAT_4_PURSUIT_ARREST_6 = 547,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_1 = 548,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_2 = 549,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_3 = 550,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_4 = 551,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_5 = 552,
	AUDIO_SAMPLE_POLICE_FBI_1_PURSUIT_ARREST_6 = 553,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_1 = 554,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_2 = 555,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_3 = 556,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_4 = 557,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_5 = 558,
	AUDIO_SAMPLE_POLICE_FBI_2_PURSUIT_ARREST_6 = 559,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_1 = 560,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_2 = 561,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_3 = 562,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_4 = 563,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_5 = 564,
	AUDIO_SAMPLE_POLICE_FBI_3_PURSUIT_ARREST_6 = 565,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_1 = 566,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_2 = 567,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_3 = 568,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_4 = 569,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_5 = 570,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_6 = 571,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_7 = 572,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_8 = 573,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_9 = 574,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_10 = 575,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_11 = 576,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_12 = 577,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_13 = 578,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_14 = 579,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_15 = 580,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_16 = 581,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_17 = 582,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_18 = 583,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_19 = 584,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_20 = 585,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_21 = 586,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_22 = 587,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_23 = 588,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_24 = 589,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_25 = 590,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_26 = 591,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_27 = 592,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_28 = 593,
	AUDIO_SAMPLE_POLICE_HELI_FOUND_PLAYER_29 = 594,
	AUDIO_SAMPLE_PED_CHUNKY_DEATH_1 = 595,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_1 = 596,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_2 = 597,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_3 = 598,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_4 = 599,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_5 = 600,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CAR_COLLISION_6 = 601,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_1 = 602,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_2 = 603,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_3 = 604,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_4 = 605,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_5 = 606,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_EVADE_1 = 607,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_EVADE_2 = 608,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_EVADE_3 = 609,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_EVADE_4 = 610,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_EVADE_5 = 611,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_SEXY_1 = 612,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_SEXY_2 = 613,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_CHAT_SEXY_3 = 614,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_ATTACK_1 = 615,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_ATTACK_2 = 616,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_ATTACK_3 = 617,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_ATTACK_4 = 618,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_ATTACK_5 = 619,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_HANDS_COWER_1 = 620,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_HANDS_COWER_2 = 621,
	AUDIO_SAMPLE_PED_BLACK_DOCKER_MALE_HANDS_COWER_3 = 622,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_1 = 623,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_2 = 624,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_3 = 625,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_4 = 626,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_5 = 627,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_6 = 628,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_7 = 629,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_8 = 630,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_9 = 631,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_10 = 632,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_11 = 633,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_12 = 634,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_13 = 635,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_14 = 636,
	AUDIO_SAMPLE_POLICE_ARMY_1_PURSUIT_15 = 637,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_1 = 638,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_2 = 639,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_3 = 640,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_4 = 641,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_5 = 642,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_6 = 643,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_7 = 644,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_8 = 645,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_9 = 646,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_10 = 647,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_11 = 648,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_12 = 649,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_13 = 650,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_14 = 651,
	AUDIO_SAMPLE_POLICE_ARMY_2_PURSUIT_15 = 652,
	AUDIO_SAMPLE_PED_HIT_REACTION_1 = 653,
	AUDIO_SAMPLE_PED_HIT_REACTION_2 = 654,
	AUDIO_SAMPLE_PED_HIT_REACTION_3 = 655,
	AUDIO_SAMPLE_PED_HIT_REACTION_4 = 656,
	AUDIO_SAMPLE_PED_HIT_REACTION_5 = 657,
	AUDIO_SAMPLE_PED_HIT_REACTION_6 = 658,
	AUDIO_SAMPLE_PED_HIT_REACTION_7 = 659,
	AUDIO_SAMPLE_PED_HIT_REACTION_8 = 660,
	AUDIO_SAMPLE_PED_HIT_REACTION_9 = 661,
	AUDIO_SAMPLE_PED_HIT_REACTION_10 = 662,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_1 = 663,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_2 = 664,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_3 = 665,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_4 = 666,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_5 = 667,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_6 = 668,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_7 = 669,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_8 = 670,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_9 = 671,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_10 = 672,
	AUDIO_SAMPLE_PED_DAMAGE_REACTION_11 = 673,
	AUDIO_SAMPLE_PED_FALL_REACTION_1 = 674,
	AUDIO_SAMPLE_PED_FALL_REACTION_2 = 675,
	AUDIO_SAMPLE_PED_FALL_REACTION_3 = 676,
	AUDIO_SAMPLE_PED_FALL_REACTION_4 = 677,
	AUDIO_SAMPLE_PED_FALL_REACTION_5 = 678,
	AUDIO_SAMPLE_PED_FALL_REACTION_6 = 679,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_1 = 680,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_2 = 681,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_3 = 682,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_4 = 683,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_5 = 684,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_6 = 685,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_COLLISION_7 = 686,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_1 = 687,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_2 = 688,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_3 = 689,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_4 = 690,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_5 = 691,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_6 = 692,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_7 = 693,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_8 = 694,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_9 = 695,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_10 = 696,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_1 = 697,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_2 = 698,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_3 = 699,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_4 = 700,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_5 = 701,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_6 = 702,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_7 = 703,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_8 = 704,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_9 = 705,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_EVADE_10 = 706,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_1 = 707,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_2 = 708,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_3 = 709,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_4 = 710,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_5 = 711,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CAR_JACKED_6 = 712,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_ROBBED_1 = 713,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_ROBBED_2 = 714,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_1 = 715,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_2 = 716,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_3 = 717,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_4 = 718,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_5 = 719,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_FLEE_RUN_6 = 720,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_EVENT_1 = 721,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_OLD_1_CHAT_EVENT_2 = 722,
	AUDIO_SAMPLE_PED_CHUNKY_FLEE_RUN_1 = 723,
	AUDIO_SAMPLE_PED_CHUNKY_FLEE_RUN_2 = 724,
	AUDIO_SAMPLE_PED_CHUNKY_FLEE_RUN_3 = 725,
	AUDIO_SAMPLE_PED_CHUNKY_FLEE_RUN_4 = 726,
	AUDIO_SAMPLE_PED_CHUNKY_FLEE_RUN_5 = 727,
	AUDIO_SAMPLE_PED_PIMP_CAR_COLLISION_1 = 728,
	AUDIO_SAMPLE_PED_PIMP_CAR_COLLISION_2 = 729,
	AUDIO_SAMPLE_PED_PIMP_CAR_COLLISION_3 = 730,
	AUDIO_SAMPLE_PED_PIMP_CAR_COLLISION_4 = 731,
	AUDIO_SAMPLE_PED_PIMP_CAR_COLLISION_5 = 732,
	AUDIO_SAMPLE_PED_PIMP_CHAT_1 = 733,
	AUDIO_SAMPLE_PED_PIMP_CHAT_2 = 734,
	AUDIO_SAMPLE_PED_PIMP_CHAT_3 = 735,
	AUDIO_SAMPLE_PED_PIMP_CHAT_4 = 736,
	AUDIO_SAMPLE_PED_PIMP_CHAT_5 = 737,
	AUDIO_SAMPLE_PED_PIMP_CHAT_6 = 738,
	AUDIO_SAMPLE_PED_PIMP_CHAT_7 = 739,
	AUDIO_SAMPLE_PED_PIMP_CHAT_8 = 740,
	AUDIO_SAMPLE_PED_PIMP_CHAT_9 = 741,
	AUDIO_SAMPLE_PED_PIMP_CHAT_10 = 742,
	AUDIO_SAMPLE_PED_PIMP_CHAT_11 = 743,
	AUDIO_SAMPLE_PED_PIMP_CHAT_12 = 744,
	AUDIO_SAMPLE_PED_PIMP_CHAT_13 = 745,
	AUDIO_SAMPLE_PED_PIMP_CHAT_14 = 746,
	AUDIO_SAMPLE_PED_PIMP_CHAT_15 = 747,
	AUDIO_SAMPLE_PED_PIMP_CHAT_16 = 748,
	AUDIO_SAMPLE_PED_PIMP_CHAT_17 = 749,
	AUDIO_SAMPLE_PED_PIMP_EVADE_1 = 750,
	AUDIO_SAMPLE_PED_PIMP_EVADE_2 = 751,
	AUDIO_SAMPLE_PED_PIMP_EVADE_3 = 752,
	AUDIO_SAMPLE_PED_PIMP_EVADE_4 = 753,
	AUDIO_SAMPLE_PED_PIMP_EVADE_5 = 754,
	AUDIO_SAMPLE_PED_PIMP_EVADE_6 = 755,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_1 = 756,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_2 = 757,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_3 = 758,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_4 = 759,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_5 = 760,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_6 = 761,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_7 = 762,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_8 = 763,
	AUDIO_SAMPLE_PED_PIMP_DEFEND_9 = 764,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_1 = 765,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_2 = 766,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_3 = 767,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_4 = 768,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_5 = 769,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_6 = 770,
	AUDIO_SAMPLE_PED_PIMP_HANDS_UP_7 = 771,
	AUDIO_SAMPLE_PED_PIMP_CAR_JACKED_1 = 772,
	AUDIO_SAMPLE_PED_PIMP_CAR_JACKED_2 = 773,
	AUDIO_SAMPLE_PED_PIMP_CAR_JACKED_3 = 774,
	AUDIO_SAMPLE_PED_PIMP_CAR_JACKED_4 = 775,
	AUDIO_SAMPLE_PED_PIMP_CHAT_EVENT_1 = 776,
	AUDIO_SAMPLE_PED_PIMP_CHAT_EVENT_2 = 777,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_1 = 778,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_2 = 779,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_3 = 780,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_4 = 781,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_5 = 782,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_6 = 783,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_7 = 784,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_8 = 785,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_9 = 786,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_10 = 787,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_11 = 788,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_COLLISION_12 = 789,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_1 = 790,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_2 = 791,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_3 = 792,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_4 = 793,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_5 = 794,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_6 = 795,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_7 = 796,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_8 = 797,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_9 = 798,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_10 = 799,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_11 = 800,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_12 = 801,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_13 = 802,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_14 = 803,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_15 = 804,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_16 = 805,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_17 = 806,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_18 = 807,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_19 = 808,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_20 = 809,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_21 = 810,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_22 = 811,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_23 = 812,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_24 = 813,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_25 = 814,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_1 = 815,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_2 = 816,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_3 = 817,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_4 = 818,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_5 = 819,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_6 = 820,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_7 = 821,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_8 = 822,
	AUDIO_SAMPLE_PED_NORMAL_MALE_EVADE_9 = 823,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_1 = 824,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_2 = 825,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_3 = 826,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_4 = 827,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_5 = 828,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_6 = 829,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_7 = 830,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_SEXY_8 = 831,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_1 = 832,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_2 = 833,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_3 = 834,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_4 = 835,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_5 = 836,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_6 = 837,
	AUDIO_SAMPLE_PED_NORMAL_MALE_HANDS_COWER_7 = 838,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_1 = 839,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_2 = 840,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_3 = 841,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_4 = 842,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_5 = 843,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_6 = 844,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CAR_JACKED_7 = 845,
	AUDIO_SAMPLE_PED_NORMAL_MALE_FLEE_RUN_1 = 846,
	AUDIO_SAMPLE_PED_NORMAL_MALE_FLEE_RUN_2 = 847,
	AUDIO_SAMPLE_PED_NORMAL_MALE_FLEE_RUN_3 = 848,
	AUDIO_SAMPLE_PED_NORMAL_MALE_FLEE_RUN_4 = 849,
	AUDIO_SAMPLE_PED_NORMAL_MALE_FLEE_RUN_5 = 850,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_1 = 851,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_2 = 852,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_3 = 853,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_4 = 854,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_5 = 855,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_6 = 856,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_7 = 857,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_8 = 858,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_9 = 859,
	AUDIO_SAMPLE_PED_NORMAL_MALE_CHAT_EVENT_10 = 860,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_1 = 861,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_2 = 862,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_3 = 863,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_4 = 864,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_5 = 865,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_6 = 866,
	AUDIO_SAMPLE_PED_BOMBER_THREAT_7 = 867,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_1 = 868,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_2 = 869,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_3 = 870,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_4 = 871,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_5 = 872,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_6 = 873,
	AUDIO_SAMPLE_PED_EIGHT_EVADE_7 = 874,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_1 = 875,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_2 = 876,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_3 = 877,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_4 = 878,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_5 = 879,
	AUDIO_SAMPLE_PED_EIGHT_ATTACK_6 = 880,
	AUDIO_SAMPLE_PED_EIGHT_HANDS_UP_1 = 881,
	AUDIO_SAMPLE_PED_EIGHT_HANDS_UP_2 = 882,
	AUDIO_SAMPLE_PED_EIGHT_ROBBED_1 = 883,
	AUDIO_SAMPLE_PED_EIGHT_ROBBED_2 = 884,
	AUDIO_SAMPLE_PED_FRANKIE_EVADE_1 = 885,
	AUDIO_SAMPLE_PED_FRANKIE_EVADE_2 = 886,
	AUDIO_SAMPLE_PED_FRANKIE_EVADE_3 = 887,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_1 = 888,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_2 = 889,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_3 = 890,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_4 = 891,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_5 = 892,
	AUDIO_SAMPLE_PED_FRANKIE_ATTACK_6 = 893,
	AUDIO_SAMPLE_PED_FRANKIE_HANDS_UP_1 = 894,
	AUDIO_SAMPLE_PED_FRANKIE_HANDS_UP_2 = 895,
	AUDIO_SAMPLE_PED_FRANKIE_HANDS_UP_3 = 896,
	AUDIO_SAMPLE_PED_FRANKIE_HANDS_UP_4 = 897,
	AUDIO_SAMPLE_PED_FRANKIE_ROBBED_1 = 898,
	AUDIO_SAMPLE_PED_FRANKIE_ROBBED_2 = 899,
	AUDIO_SAMPLE_PED_MISTY_EVADE_1 = 900,
	AUDIO_SAMPLE_PED_MISTY_EVADE_2 = 901,
	AUDIO_SAMPLE_PED_MISTY_EVADE_3 = 902,
	AUDIO_SAMPLE_PED_MISTY_EVADE_4 = 903,
	AUDIO_SAMPLE_PED_MISTY_EVADE_5 = 904,
	AUDIO_SAMPLE_PED_MISTY_ATTACK_1 = 905,
	AUDIO_SAMPLE_PED_MISTY_ATTACK_2 = 906,
	AUDIO_SAMPLE_PED_MISTY_ATTACK_3 = 907,
	AUDIO_SAMPLE_PED_MISTY_ATTACK_4 = 908,
	AUDIO_SAMPLE_PED_MISTY_HANDS_UP_1 = 909,
	AUDIO_SAMPLE_PED_MISTY_HANDS_UP_2 = 910,
	AUDIO_SAMPLE_PED_MISTY_HANDS_UP_3 = 911,
	AUDIO_SAMPLE_PED_MISTY_HANDS_UP_4 = 912,
	AUDIO_SAMPLE_PED_MISTY_HANDS_UP_5 = 913,
	AUDIO_SAMPLE_PED_MISTY_THUMB_LIFT_1 = 914,
	AUDIO_SAMPLE_PED_MISTY_THUMB_LIFT_2 = 915,
	AUDIO_SAMPLE_PED_MISTY_THUMB_LIFT_3 = 916,
	AUDIO_SAMPLE_PED_MISTY_THUMB_LIFT_4 = 917,
	AUDIO_SAMPLE_PED_MISTY_ROBBED_1 = 918,
	AUDIO_SAMPLE_PED_MISTY_ROBBED_2 = 919,
	AUDIO_SAMPLE_PED_MEDIC_1_HANDS_COWER_1 = 920,
	AUDIO_SAMPLE_PED_MEDIC_1_HANDS_COWER_2 = 921,
	AUDIO_SAMPLE_PED_MEDIC_1_HANDS_COWER_3 = 922,
	AUDIO_SAMPLE_PED_MEDIC_1_HANDS_COWER_4 = 923,
	AUDIO_SAMPLE_PED_MEDIC_1_HANDS_COWER_5 = 924,
	AUDIO_SAMPLE_PED_MEDIC_1_CAR_JACKED_1 = 925,
	AUDIO_SAMPLE_PED_MEDIC_1_CAR_JACKED_2 = 926,
	AUDIO_SAMPLE_PED_MEDIC_1_CAR_JACKED_3 = 927,
	AUDIO_SAMPLE_PED_MEDIC_1_CAR_JACKED_4 = 928,
	AUDIO_SAMPLE_PED_MEDIC_1_CAR_JACKED_5 = 929,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_1 = 930,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_2 = 931,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_3 = 932,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_4 = 933,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_5 = 934,
	AUDIO_SAMPLE_PED_MEDIC_1_FLEE_RUN_6 = 935,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_1 = 936,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_2 = 937,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_3 = 938,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_4 = 939,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_5 = 940,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_6 = 941,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_7 = 942,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_8 = 943,
	AUDIO_SAMPLE_PED_MEDIC_1_LEAVE_VEHICLE_9 = 944,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_1 = 945,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_2 = 946,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_3 = 947,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_4 = 948,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_5 = 949,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_6 = 950,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_7 = 951,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_8 = 952,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_9 = 953,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_10 = 954,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_11 = 955,
	AUDIO_SAMPLE_PED_MEDIC_1_HEALING_12 = 956,
	AUDIO_SAMPLE_PED_MEDIC_2_HANDS_COWER_1 = 957,
	AUDIO_SAMPLE_PED_MEDIC_2_HANDS_COWER_2 = 958,
	AUDIO_SAMPLE_PED_MEDIC_2_HANDS_COWER_3 = 959,
	AUDIO_SAMPLE_PED_MEDIC_2_HANDS_COWER_4 = 960,
	AUDIO_SAMPLE_PED_MEDIC_2_HANDS_COWER_5 = 961,
	AUDIO_SAMPLE_PED_MEDIC_2_CAR_JACKED_1 = 962,
	AUDIO_SAMPLE_PED_MEDIC_2_CAR_JACKED_2 = 963,
	AUDIO_SAMPLE_PED_MEDIC_2_CAR_JACKED_3 = 964,
	AUDIO_SAMPLE_PED_MEDIC_2_CAR_JACKED_4 = 965,
	AUDIO_SAMPLE_PED_MEDIC_2_CAR_JACKED_5 = 966,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_1 = 967,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_2 = 968,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_3 = 969,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_4 = 970,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_5 = 971,
	AUDIO_SAMPLE_PED_MEDIC_2_FLEE_RUN_6 = 972,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_1 = 973,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_2 = 974,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_3 = 975,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_4 = 976,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_5 = 977,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_6 = 978,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_7 = 979,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_8 = 980,
	AUDIO_SAMPLE_PED_MEDIC_2_LEAVE_VEHICLE_9 = 981,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_1 = 982,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_2 = 983,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_3 = 984,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_4 = 985,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_5 = 986,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_6 = 987,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_7 = 988,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_8 = 989,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_9 = 990,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_10 = 991,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_11 = 992,
	AUDIO_SAMPLE_PED_MEDIC_2_HEALING_12 = 993,
	AUDIO_SAMPLE_PED_BODYCAST_HIT_1 = 994,
	AUDIO_SAMPLE_PED_BODYCAST_HIT_2 = 995,
	AUDIO_SAMPLE_PED_BODYCAST_HIT_3 = 996,
	AUDIO_SAMPLE_PED_BODYCAST_HIT_4 = 997,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_COLLISION_1 = 998,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_COLLISION_2 = 999,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_COLLISION_3 = 1000,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_COLLISION_4 = 1001,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_COLLISION_5 = 1002,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_1 = 1003,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_2 = 1004,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_3 = 1005,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_4 = 1006,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_EVADE_1 = 1007,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_EVADE_2 = 1008,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_EVADE_3 = 1009,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_EVADE_4 = 1010,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_EVADE_5 = 1011,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_SEXY_1 = 1012,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_SEXY_2 = 1013,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_SEXY_3 = 1014,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CHAT_SEXY_4 = 1015,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_ATTACK_1 = 1016,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_ATTACK_2 = 1017,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_ATTACK_3 = 1018,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_ATTACK_4 = 1019,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_ATTACK_5 = 1020,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_HANDS_COWER_1 = 1021,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_HANDS_COWER_2 = 1022,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_HANDS_COWER_3 = 1023,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_JACKED_1 = 1024,
	AUDIO_SAMPLE_PED_BLACK_CONSTRUCTION_WORKER_CAR_JACKED_2 = 1025,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CAR_COLLISION_1 = 1026,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CAR_COLLISION_2 = 1027,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CAR_COLLISION_3 = 1028,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CAR_COLLISION_4 = 1029,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CAR_COLLISION_5 = 1030,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_1 = 1031,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_2 = 1032,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_3 = 1033,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_4 = 1034,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_5 = 1035,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_6 = 1036,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_EVADE_1 = 1037,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_EVADE_2 = 1038,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_EVADE_3 = 1039,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_EVADE_4 = 1040,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_ROBBED_1 = 1041,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_EVENT_1 = 1042,
	AUDIO_SAMPLE_PED_FAN_FEMALE_1_CHAT_EVENT_2 = 1043,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CAR_COLLISION_1 = 1044,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CAR_COLLISION_2 = 1045,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CAR_COLLISION_3 = 1046,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CAR_COLLISION_4 = 1047,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CAR_COLLISION_5 = 1048,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_1 = 1049,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_2 = 1050,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_3 = 1051,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_4 = 1052,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_5 = 1053,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_6 = 1054,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_EVADE_1 = 1055,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_EVADE_2 = 1056,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_EVADE_3 = 1057,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_EVADE_4 = 1058,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_ROBBED_1 = 1059,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_EVENT_1 = 1060,
	AUDIO_SAMPLE_PED_FAN_FEMALE_2_CHAT_EVENT_2 = 1061,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CAR_COLLISION_1 = 1062,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CAR_COLLISION_2 = 1063,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CAR_COLLISION_3 = 1064,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CAR_COLLISION_4 = 1065,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CAR_COLLISION_5 = 1066,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_1 = 1067,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_2 = 1068,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_3 = 1069,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_4 = 1070,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_5 = 1071,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_6 = 1072,
	AUDIO_SAMPLE_PED_FAN_MALE_1_EVADE_1 = 1073,
	AUDIO_SAMPLE_PED_FAN_MALE_1_EVADE_2 = 1074,
	AUDIO_SAMPLE_PED_FAN_MALE_1_EVADE_3 = 1075,
	AUDIO_SAMPLE_PED_FAN_MALE_1_EVADE_4 = 1076,
	AUDIO_SAMPLE_PED_FAN_MALE_1_ATTACK_1 = 1077,
	AUDIO_SAMPLE_PED_FAN_MALE_1_ATTACK_2 = 1078,
	AUDIO_SAMPLE_PED_FAN_MALE_1_ATTACK_3 = 1079,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_EVENT_1 = 1080,
	AUDIO_SAMPLE_PED_FAN_MALE_1_CHAT_EVENT_2 = 1081,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CAR_COLLISION_1 = 1082,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CAR_COLLISION_2 = 1083,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CAR_COLLISION_3 = 1084,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CAR_COLLISION_4 = 1085,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CAR_COLLISION_5 = 1086,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_1 = 1087,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_2 = 1088,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_3 = 1089,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_4 = 1090,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_5 = 1091,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_6 = 1092,
	AUDIO_SAMPLE_PED_FAN_MALE_2_EVADE_1 = 1093,
	AUDIO_SAMPLE_PED_FAN_MALE_2_EVADE_2 = 1094,
	AUDIO_SAMPLE_PED_FAN_MALE_2_EVADE_3 = 1095,
	AUDIO_SAMPLE_PED_FAN_MALE_2_EVADE_4 = 1096,
	AUDIO_SAMPLE_PED_FAN_MALE_2_ATTACK_1 = 1097,
	AUDIO_SAMPLE_PED_FAN_MALE_2_ATTACK_2 = 1098,
	AUDIO_SAMPLE_PED_FAN_MALE_2_ATTACK_3 = 1099,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_EVENT_1 = 1100,
	AUDIO_SAMPLE_PED_FAN_MALE_2_CHAT_EVENT_2 = 1101,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_1 = 1102,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_2 = 1103,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_3 = 1104,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_4 = 1105,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_5 = 1106,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_6 = 1107,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CAR_COLLISION_7 = 1108,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_1 = 1109,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_2 = 1110,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_3 = 1111,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_4 = 1112,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_5 = 1113,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_6 = 1114,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_7 = 1115,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_8 = 1116,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_EVADE_1 = 1117,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_EVADE_2 = 1118,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_EVADE_3 = 1119,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_EVADE_4 = 1120,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_HANDS_COWER_1 = 1121,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_HANDS_COWER_2 = 1122,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_HANDS_COWER_3 = 1123,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_HANDS_COWER_4 = 1124,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_ROBBED_1 = 1125,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_ROBBED_2 = 1126,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_ROBBED_3 = 1127,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_EVENT_1 = 1128,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_EVENT_2 = 1129,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_EVENT_3 = 1130,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_EVENT_4 = 1131,
	AUDIO_SAMPLE_PED_SUPERMODEL_FEMALE_CHAT_EVENT_5 = 1132,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_1 = 1133,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_2 = 1134,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_3 = 1135,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_4 = 1136,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_5 = 1137,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_COLLISION_6 = 1138,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_1 = 1139,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_2 = 1140,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_3 = 1141,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_4 = 1142,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_5 = 1143,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_6 = 1144,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_1 = 1145,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_2 = 1146,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_3 = 1147,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_4 = 1148,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_5 = 1149,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_EVADE_6 = 1150,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_SEXY_1 = 1151,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_SEXY_2 = 1152,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CHAT_SEXY_3 = 1153,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ATTACK_1 = 1154,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ATTACK_2 = 1155,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ATTACK_3 = 1156,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ATTACK_4 = 1157,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ATTACK_5 = 1158,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_JACKED_1 = 1159,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_CAR_JACKED_2 = 1160,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ROBBED_1 = 1161,
	AUDIO_SAMPLE_PED_SUPERMODEL_MALE_ROBBED_2 = 1162,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_1 = 1163,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_2 = 1164,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_3 = 1165,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_4 = 1166,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_5 = 1167,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_COLLISION_6 = 1168,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_1 = 1169,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_2 = 1170,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_3 = 1171,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_4 = 1172,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_5 = 1173,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_6 = 1174,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_EVADE_1 = 1175,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_EVADE_2 = 1176,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_EVADE_3 = 1177,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_EVADE_4 = 1178,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_EVADE_5 = 1179,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_SEXY_1 = 1180,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_SEXY_2 = 1181,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CHAT_SEXY_3 = 1182,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_1 = 1183,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_2 = 1184,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_3 = 1185,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_4 = 1186,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_5 = 1187,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_ATTACK_6 = 1188,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_HANDS_COWER_1 = 1189,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_HANDS_COWER_2 = 1190,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_JACKED_1 = 1191,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_YOUNG_CAR_JACKED_2 = 1192,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_1 = 1193,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_2 = 1194,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_3 = 1195,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_4 = 1196,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_5 = 1197,
	AUDIO_SAMPLE_PED_SCUM_MALE_CAR_COLLISION_6 = 1198,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_1 = 1199,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_2 = 1200,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_3 = 1201,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_4 = 1202,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_5 = 1203,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_6 = 1204,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_7 = 1205,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_8 = 1206,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_9 = 1207,
	AUDIO_SAMPLE_PED_SCUM_MALE_EVADE_1 = 1208,
	AUDIO_SAMPLE_PED_SCUM_MALE_EVADE_2 = 1209,
	AUDIO_SAMPLE_PED_SCUM_MALE_EVADE_3 = 1210,
	AUDIO_SAMPLE_PED_SCUM_MALE_EVADE_4 = 1211,
	AUDIO_SAMPLE_PED_SCUM_MALE_EVADE_5 = 1212,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_SEXY_1 = 1213,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_SEXY_2 = 1214,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_SEXY_3 = 1215,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_SEXY_4 = 1216,
	AUDIO_SAMPLE_PED_SCUM_MALE_CHAT_SEXY_5 = 1217,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_1 = 1218,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_2 = 1219,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_3 = 1220,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_4 = 1221,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_5 = 1222,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_6 = 1223,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_7 = 1224,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_8 = 1225,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_9 = 1226,
	AUDIO_SAMPLE_PED_SCUM_MALE_ATTACK_10 = 1227,
	AUDIO_SAMPLE_PED_SCUM_MALE_HANDS_COWER_1 = 1228,
	AUDIO_SAMPLE_PED_SCUM_MALE_HANDS_COWER_2 = 1229,
	AUDIO_SAMPLE_PED_SCUM_MALE_HANDS_COWER_3 = 1230,
	AUDIO_SAMPLE_PED_SCUM_MALE_HANDS_COWER_4 = 1231,
	AUDIO_SAMPLE_PED_SCUM_MALE_HANDS_COWER_5 = 1232,
	AUDIO_SAMPLE_PED_SCUM_MALE_WAIT_DOUBLEBACK_1 = 1233,
	AUDIO_SAMPLE_PED_SCUM_MALE_WAIT_DOUBLEBACK_2 = 1234,
	AUDIO_SAMPLE_PED_SCUM_MALE_WAIT_DOUBLEBACK_3 = 1235,
	AUDIO_SAMPLE_PED_SCUM_MALE_ROBBED_1 = 1236,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CAR_COLLISION_1 = 1237,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CAR_COLLISION_2 = 1238,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CAR_COLLISION_3 = 1239,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CAR_COLLISION_4 = 1240,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CAR_COLLISION_5 = 1241,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_1 = 1242,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_2 = 1243,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_3 = 1244,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_4 = 1245,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_5 = 1246,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_6 = 1247,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_7 = 1248,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_8 = 1249,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_9 = 1250,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_10 = 1251,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_11 = 1252,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_12 = 1253,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_CHAT_13 = 1254,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_1 = 1255,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_2 = 1256,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_3 = 1257,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_4 = 1258,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_5 = 1259,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_6 = 1260,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_7 = 1261,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_EVADE_8 = 1262,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ATTACK_1 = 1263,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ATTACK_2 = 1264,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ATTACK_3 = 1265,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ATTACK_4 = 1266,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_HANDS_COWER_1 = 1267,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_HANDS_COWER_2 = 1268,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_HANDS_COWER_3 = 1269,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_HANDS_COWER_4 = 1270,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ROBBED_1 = 1271,
	AUDIO_SAMPLE_PED_SCUM_FEMALE_ROBBED_2 = 1272,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_1 = 1273,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_2 = 1274,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_3 = 1275,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_4 = 1276,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_5 = 1277,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_COLLISION_6 = 1278,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_1 = 1279,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_2 = 1280,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_3 = 1281,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_4 = 1282,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_5 = 1283,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_6 = 1284,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_7 = 1285,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_EVADE_1 = 1286,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_EVADE_2 = 1287,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_EVADE_3 = 1288,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_EVADE_4 = 1289,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_EVADE_5 = 1290,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_HANDS_COWER_1 = 1291,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_HANDS_COWER_2 = 1292,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_HANDS_COWER_3 = 1293,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_HANDS_COWER_4 = 1294,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CAR_JACKED_1 = 1295,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_ROBBED_1 = 1296,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_ROBBED_2 = 1297,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_EVENT_1 = 1298,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_EVENT_2 = 1299,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_EVENT_3 = 1300,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_EVENT_4 = 1301,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_FEMALE_YOUNG_1_CHAT_EVENT_5 = 1302,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_1 = 1303,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_2 = 1304,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_3 = 1305,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_4 = 1306,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_5 = 1307,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_COLLISION_6 = 1308,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_1 = 1309,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_2 = 1310,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_3 = 1311,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_4 = 1312,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_5 = 1313,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CHAT_6 = 1314,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_EVADE_1 = 1315,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_EVADE_2 = 1316,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_EVADE_3 = 1317,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_EVADE_4 = 1318,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ATTACK_1 = 1319,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ATTACK_2 = 1320,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ATTACK_3 = 1321,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ATTACK_4 = 1322,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_HANDS_COWER_1 = 1323,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_HANDS_COWER_2 = 1324,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_HANDS_COWER_3 = 1325,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_JACKED_1 = 1326,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_CAR_JACKED_2 = 1327,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ROBBED_1 = 1328,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_ROBBED_2 = 1329,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_FLEE_RUN_1 = 1330,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_FLEE_RUN_2 = 1331,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_FLEE_RUN_3 = 1332,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_FLEE_RUN_4 = 1333,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_YOUNG_1_FLEE_RUN_5 = 1334,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_1 = 1335,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_2 = 1336,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_3 = 1337,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_4 = 1338,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_5 = 1339,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_COLLISION_6 = 1340,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_1 = 1341,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_2 = 1342,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_3 = 1343,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_4 = 1344,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_5 = 1345,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CHAT_6 = 1346,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_EVADE_1 = 1347,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_EVADE_2 = 1348,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_EVADE_3 = 1349,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_EVADE_4 = 1350,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ATTACK_1 = 1351,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ATTACK_2 = 1352,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ATTACK_3 = 1353,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ATTACK_4 = 1354,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_HANDS_COWER_1 = 1355,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_HANDS_COWER_2 = 1356,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_HANDS_COWER_3 = 1357,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_JACKED_1 = 1358,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_CAR_JACKED_2 = 1359,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ROBBED_1 = 1360,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_ROBBED_2 = 1361,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_FLEE_RUN_1 = 1362,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_FLEE_RUN_2 = 1363,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_FLEE_RUN_3 = 1364,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_FLEE_RUN_4 = 1365,
	AUDIO_SAMPLE_PED_LAZLOW_UNUSED_FLEE_RUN_5 = 1366,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_1 = 1367,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_2 = 1368,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_3 = 1369,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_4 = 1370,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_5 = 1371,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_COLLISION_6 = 1372,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_1 = 1373,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_2 = 1374,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_3 = 1375,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_4 = 1376,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_5 = 1377,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_6 = 1378,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_7 = 1379,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_EVADE_1 = 1380,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_EVADE_2 = 1381,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_EVADE_3 = 1382,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_EVADE_4 = 1383,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_EVADE_5 = 1384,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_HANDS_COWER_1 = 1385,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_HANDS_COWER_2 = 1386,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_HANDS_COWER_3 = 1387,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_HANDS_COWER_4 = 1388,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_JACKED_1 = 1389,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CAR_JACKED_2 = 1390,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_ROBBED_1 = 1391,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_ROBBED_2 = 1392,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_EVENT_1 = 1393,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_EVENT_2 = 1394,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_EVENT_3 = 1395,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_EVENT_4 = 1396,
	AUDIO_SAMPLE_PED_BLACK_FAT_FEMALE_1_CHAT_EVENT_5 = 1397,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CAR_COLLISION_1 = 1398,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CAR_COLLISION_2 = 1399,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CAR_COLLISION_3 = 1400,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CAR_COLLISION_4 = 1401,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_1 = 1402,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_2 = 1403,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_3 = 1404,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_4 = 1405,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_5 = 1406,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_EVADE_1 = 1407,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_EVADE_2 = 1408,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_EVADE_3 = 1409,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_EVADE_4 = 1410,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_SEXY_1 = 1411,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_SEXY_2 = 1412,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_CHAT_SEXY_3 = 1413,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_ATTACK_1 = 1414,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_ATTACK_2 = 1415,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_ATTACK_3 = 1416,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_HANDS_COWER_1 = 1417,
	AUDIO_SAMPLE_PED_WHITE_DOCKER_MALE_HANDS_COWER_2 = 1418,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CAR_COLLISION_1 = 1419,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CAR_COLLISION_2 = 1420,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CAR_COLLISION_3 = 1421,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CAR_COLLISION_4 = 1422,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CAR_COLLISION_5 = 1423,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CHAT_1 = 1424,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CHAT_2 = 1425,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CHAT_3 = 1426,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CHAT_4 = 1427,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_CHAT_5 = 1428,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_EVADE_1 = 1429,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_EVADE_2 = 1430,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_EVADE_3 = 1431,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_EVADE_4 = 1432,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_ATTACK_1 = 1433,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_ATTACK_2 = 1434,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_ATTACK_3 = 1435,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_ATTACK_4 = 1436,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_HANDS_COWER_1 = 1437,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_HANDS_COWER_2 = 1438,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_HANDS_COWER_3 = 1439,
	AUDIO_SAMPLE_PED_HOSPITAL_MALE_HANDS_COWER_4 = 1440,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_1 = 1441,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_2 = 1442,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_3 = 1443,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_4 = 1444,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_5 = 1445,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CAR_COLLISION_6 = 1446,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_1 = 1447,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_2 = 1448,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_3 = 1449,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_4 = 1450,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_5 = 1451,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_CHAT_6 = 1452,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_EVADE_1 = 1453,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_EVADE_2 = 1454,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_EVADE_3 = 1455,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_EVADE_4 = 1456,
	AUDIO_SAMPLE_PED_HOSPITAL_FEMALE_EVADE_5 = 1457,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_1 = 1458,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_2 = 1459,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_3 = 1460,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_4 = 1461,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_5 = 1462,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_6 = 1463,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_COLLISION_7 = 1464,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_1 = 1465,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_2 = 1466,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_3 = 1467,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_4 = 1468,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_5 = 1469,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_6 = 1470,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_7 = 1471,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_8 = 1472,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_1 = 1473,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_2 = 1474,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_3 = 1475,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_4 = 1476,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_5 = 1477,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_EVADE_6 = 1478,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_HANDS_COWER_1 = 1479,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_HANDS_COWER_2 = 1480,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_JACKED_1 = 1481,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CAR_JACKED_2 = 1482,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_ROBBED_1 = 1483,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_ROBBED_2 = 1484,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_ROBBED_3 = 1485,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_FLEE_RUN_1 = 1486,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_FLEE_RUN_2 = 1487,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_EVENT_1 = 1488,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_EVENT_2 = 1489,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_EVENT_3 = 1490,
	AUDIO_SAMPLE_PED_BLACK_CASUAL_FEMALE_1_CHAT_EVENT_4 = 1491,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_1 = 1492,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_2 = 1493,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_3 = 1494,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_4 = 1495,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_5 = 1496,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_COLLISION_6 = 1497,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_1 = 1498,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_2 = 1499,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_3 = 1500,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_4 = 1501,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_5 = 1502,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_1 = 1503,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_2 = 1504,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_3 = 1505,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_4 = 1506,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_5 = 1507,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_EVADE_6 = 1508,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_HANDS_COWER_1 = 1509,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_HANDS_COWER_2 = 1510,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_HANDS_COWER_3 = 1511,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_HANDS_COWER_4 = 1512,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_HANDS_COWER_5 = 1513,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_JACKED_1 = 1514,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_JACKED_2 = 1515,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CAR_JACKED_3 = 1516,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_ROBBED_1 = 1517,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_ROBBED_2 = 1518,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_ROBBED_3 = 1519,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_FLEE_RUN_1 = 1520,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_FLEE_RUN_2 = 1521,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_FLEE_RUN_3 = 1522,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_FLEE_RUN_4 = 1523,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_EVENT_1 = 1524,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_EVENT_2 = 1525,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_EVENT_3 = 1526,
	AUDIO_SAMPLE_PED_FEMALE_NO_3_CHAT_EVENT_4 = 1527,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_1 = 1528,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_2 = 1529,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_3 = 1530,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_4 = 1531,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_5 = 1532,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_6 = 1533,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_COLLISION_7 = 1534,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_1 = 1535,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_2 = 1536,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_3 = 1537,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_4 = 1538,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_5 = 1539,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_6 = 1540,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_7 = 1541,
	AUDIO_SAMPLE_PED_MALE_NO_2_EVADE_1 = 1542,
	AUDIO_SAMPLE_PED_MALE_NO_2_EVADE_2 = 1543,
	AUDIO_SAMPLE_PED_MALE_NO_2_EVADE_3 = 1544,
	AUDIO_SAMPLE_PED_MALE_NO_2_EVADE_4 = 1545,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_SEXY_1 = 1546,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_SEXY_2 = 1547,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_SEXY_3 = 1548,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_SEXY_4 = 1549,
	AUDIO_SAMPLE_PED_MALE_NO_2_CHAT_SEXY_5 = 1550,
	AUDIO_SAMPLE_PED_MALE_NO_2_ATTACK_1 = 1551,
	AUDIO_SAMPLE_PED_MALE_NO_2_ATTACK_2 = 1552,
	AUDIO_SAMPLE_PED_MALE_NO_2_ATTACK_3 = 1553,
	AUDIO_SAMPLE_PED_MALE_NO_2_ATTACK_4 = 1554,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_JACKED_1 = 1555,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_JACKED_2 = 1556,
	AUDIO_SAMPLE_PED_MALE_NO_2_CAR_JACKED_3 = 1557,
	AUDIO_SAMPLE_PED_MALE_NO_2_ROBBED_1 = 1558,
	AUDIO_SAMPLE_PED_MALE_NO_2_ROBBED_2 = 1559,
	AUDIO_SAMPLE_PED_MALE_NO_2_ROBBED_3 = 1560,
	AUDIO_SAMPLE_PED_MALE_NO_2_ROBBED_4 = 1561,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CAR_COLLISION_1 = 1562,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CAR_COLLISION_2 = 1563,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CAR_COLLISION_3 = 1564,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CAR_COLLISION_4 = 1565,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_1 = 1566,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_2 = 1567,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_3 = 1568,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_4 = 1569,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_5 = 1570,
	AUDIO_SAMPLE_PED_STUDENT_MALE_EVADE_1 = 1571,
	AUDIO_SAMPLE_PED_STUDENT_MALE_EVADE_2 = 1572,
	AUDIO_SAMPLE_PED_STUDENT_MALE_EVADE_3 = 1573,
	AUDIO_SAMPLE_PED_STUDENT_MALE_EVADE_4 = 1574,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ATTACK_1 = 1575,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ATTACK_2 = 1576,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ATTACK_3 = 1577,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ATTACK_4 = 1578,
	AUDIO_SAMPLE_PED_STUDENT_MALE_HANDS_COWER_1 = 1579,
	AUDIO_SAMPLE_PED_STUDENT_MALE_HANDS_COWER_2 = 1580,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ROBBED_1 = 1581,
	AUDIO_SAMPLE_PED_STUDENT_MALE_ROBBED_2 = 1582,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_EVENT_1 = 1583,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_EVENT_2 = 1584,
	AUDIO_SAMPLE_PED_STUDENT_MALE_CHAT_EVENT_3 = 1585,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CAR_COLLISION_1 = 1586,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CAR_COLLISION_2 = 1587,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CAR_COLLISION_3 = 1588,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CAR_COLLISION_4 = 1589,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_1 = 1590,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_2 = 1591,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_3 = 1592,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_4 = 1593,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_EVADE_1 = 1594,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_EVADE_2 = 1595,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_EVADE_3 = 1596,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_EVADE_4 = 1597,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ATTACK_1 = 1598,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ATTACK_2 = 1599,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ATTACK_3 = 1600,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ATTACK_4 = 1601,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_HANDS_COWER_1 = 1602,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_HANDS_COWER_2 = 1603,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_HANDS_COWER_3 = 1604,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_HANDS_COWER_4 = 1605,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ROBBED_1 = 1606,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_ROBBED_2 = 1607,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_EVENT_1 = 1608,
	AUDIO_SAMPLE_PED_STUDENT_FEMALE_CHAT_EVENT_2 = 1609,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_1 = 1610,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_2 = 1611,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_3 = 1612,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_4 = 1613,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_5 = 1614,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_6 = 1615,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_COLLISION_7 = 1616,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_1 = 1617,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_2 = 1618,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_3 = 1619,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_4 = 1620,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_5 = 1621,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_6 = 1622,
	AUDIO_SAMPLE_PED_HOODS_1_EVADE_1 = 1623,
	AUDIO_SAMPLE_PED_HOODS_1_EVADE_2 = 1624,
	AUDIO_SAMPLE_PED_HOODS_1_EVADE_3 = 1625,
	AUDIO_SAMPLE_PED_HOODS_1_EVADE_4 = 1626,
	AUDIO_SAMPLE_PED_HOODS_1_EVADE_5 = 1627,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_SEXY_1 = 1628,
	AUDIO_SAMPLE_PED_HOODS_1_CHAT_SEXY_2 = 1629,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_1 = 1630,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_2 = 1631,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_3 = 1632,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_4 = 1633,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_5 = 1634,
	AUDIO_SAMPLE_PED_HOODS_1_ATTACK_6 = 1635,
	AUDIO_SAMPLE_PED_HOODS_1_HANDS_UP_1 = 1636,
	AUDIO_SAMPLE_PED_HOODS_1_HANDS_UP_2 = 1637,
	AUDIO_SAMPLE_PED_HOODS_1_HANDS_UP_3 = 1638,
	AUDIO_SAMPLE_PED_HOODS_1_HANDS_UP_4 = 1639,
	AUDIO_SAMPLE_PED_HOODS_1_HANDS_UP_5 = 1640,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_JACKED_1 = 1641,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_JACKED_2 = 1642,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_JACKING_1 = 1643,
	AUDIO_SAMPLE_PED_HOODS_1_CAR_JACKING_2 = 1644,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_1 = 1645,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_2 = 1646,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_3 = 1647,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_4 = 1648,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_5 = 1649,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_6 = 1650,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_COLLISION_7 = 1651,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_1 = 1652,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_2 = 1653,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_3 = 1654,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_4 = 1655,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_5 = 1656,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_6 = 1657,
	AUDIO_SAMPLE_PED_HOODS_2_EVADE_1 = 1658,
	AUDIO_SAMPLE_PED_HOODS_2_EVADE_2 = 1659,
	AUDIO_SAMPLE_PED_HOODS_2_EVADE_3 = 1660,
	AUDIO_SAMPLE_PED_HOODS_2_EVADE_4 = 1661,
	AUDIO_SAMPLE_PED_HOODS_2_EVADE_5 = 1662,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_SEXY_1 = 1663,
	AUDIO_SAMPLE_PED_HOODS_2_CHAT_SEXY_2 = 1664,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_1 = 1665,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_2 = 1666,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_3 = 1667,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_4 = 1668,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_5 = 1669,
	AUDIO_SAMPLE_PED_HOODS_2_ATTACK_6 = 1670,
	AUDIO_SAMPLE_PED_HOODS_2_HANDS_UP_1 = 1671,
	AUDIO_SAMPLE_PED_HOODS_2_HANDS_UP_2 = 1672,
	AUDIO_SAMPLE_PED_HOODS_2_HANDS_UP_3 = 1673,
	AUDIO_SAMPLE_PED_HOODS_2_HANDS_UP_4 = 1674,
	AUDIO_SAMPLE_PED_HOODS_2_HANDS_UP_5 = 1675,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_JACKED_1 = 1676,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_JACKED_2 = 1677,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_JACKING_1 = 1678,
	AUDIO_SAMPLE_PED_HOODS_2_CAR_JACKING_2 = 1679,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_1 = 1680,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_2 = 1681,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_3 = 1682,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_4 = 1683,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_5 = 1684,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_COLLISION_6 = 1685,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_1 = 1686,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_2 = 1687,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_3 = 1688,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_4 = 1689,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_5 = 1690,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_6 = 1691,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_7 = 1692,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_8 = 1693,
	AUDIO_SAMPLE_PED_YARDIE_1_EVADE_1 = 1694,
	AUDIO_SAMPLE_PED_YARDIE_1_EVADE_2 = 1695,
	AUDIO_SAMPLE_PED_YARDIE_1_EVADE_3 = 1696,
	AUDIO_SAMPLE_PED_YARDIE_1_EVADE_4 = 1697,
	AUDIO_SAMPLE_PED_YARDIE_1_EVADE_5 = 1698,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_SEXY_1 = 1699,
	AUDIO_SAMPLE_PED_YARDIE_1_CHAT_SEXY_2 = 1700,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_1 = 1701,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_2 = 1702,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_3 = 1703,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_4 = 1704,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_5 = 1705,
	AUDIO_SAMPLE_PED_YARDIE_1_ATTACK_6 = 1706,
	AUDIO_SAMPLE_PED_YARDIE_1_HANDS_UP_1 = 1707,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_JACKED_1 = 1708,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_JACKING_1 = 1709,
	AUDIO_SAMPLE_PED_YARDIE_1_CAR_JACKING_2 = 1710,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_1 = 1711,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_2 = 1712,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_3 = 1713,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_4 = 1714,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_5 = 1715,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_COLLISION_6 = 1716,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_1 = 1717,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_2 = 1718,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_3 = 1719,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_4 = 1720,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_5 = 1721,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_6 = 1722,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_7 = 1723,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_8 = 1724,
	AUDIO_SAMPLE_PED_YARDIE_2_EVADE_1 = 1725,
	AUDIO_SAMPLE_PED_YARDIE_2_EVADE_2 = 1726,
	AUDIO_SAMPLE_PED_YARDIE_2_EVADE_3 = 1727,
	AUDIO_SAMPLE_PED_YARDIE_2_EVADE_4 = 1728,
	AUDIO_SAMPLE_PED_YARDIE_2_EVADE_5 = 1729,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_SEXY_1 = 1730,
	AUDIO_SAMPLE_PED_YARDIE_2_CHAT_SEXY_2 = 1731,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_1 = 1732,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_2 = 1733,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_3 = 1734,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_4 = 1735,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_5 = 1736,
	AUDIO_SAMPLE_PED_YARDIE_2_ATTACK_6 = 1737,
	AUDIO_SAMPLE_PED_YARDIE_2_HANDS_UP_1 = 1738,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_JACKED_1 = 1739,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_JACKING_1 = 1740,
	AUDIO_SAMPLE_PED_YARDIE_2_CAR_JACKING_2 = 1741,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_1 = 1742,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_2 = 1743,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_3 = 1744,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_4 = 1745,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_5 = 1746,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_6 = 1747,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_COLLISION_7 = 1748,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_1 = 1749,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_2 = 1750,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_3 = 1751,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_4 = 1752,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_5 = 1753,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_6 = 1754,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_7 = 1755,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_1 = 1756,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_2 = 1757,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_3 = 1758,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_4 = 1759,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_5 = 1760,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_EVADE_6 = 1761,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_HANDS_COWER_1 = 1762,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_HANDS_COWER_2 = 1763,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_HANDS_COWER_3 = 1764,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_HANDS_COWER_4 = 1765,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_HANDS_COWER_5 = 1766,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_JACKED_1 = 1767,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_JACKED_2 = 1768,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_JACKED_3 = 1769,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CAR_JACKED_4 = 1770,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_ROBBED_1 = 1771,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_ROBBED_2 = 1772,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_ROBBED_3 = 1773,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_1 = 1774,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_2 = 1775,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_3 = 1776,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_4 = 1777,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_5 = 1778,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_FLEE_RUN_6 = 1779,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_EVENT_1 = 1780,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_EVENT_2 = 1781,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_EVENT_3 = 1782,
	AUDIO_SAMPLE_PED_BLACK_BUSINESS_FEMALE_CHAT_EVENT_4 = 1783,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_1 = 1784,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_2 = 1785,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_3 = 1786,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_4 = 1787,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_5 = 1788,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CAR_COLLISION_6 = 1789,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_1 = 1790,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_2 = 1791,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_3 = 1792,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_4 = 1793,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_5 = 1794,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_6 = 1795,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_EVADE_1 = 1796,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_EVADE_2 = 1797,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_EVADE_3 = 1798,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_EVADE_4 = 1799,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_SEXY_1 = 1800,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_CHAT_SEXY_2 = 1801,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_ATTACK_1 = 1802,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_ATTACK_2 = 1803,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_ATTACK_3 = 1804,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_HANDS_COWER_1 = 1805,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_HANDS_COWER_2 = 1806,
	AUDIO_SAMPLE_PED_WHITE_WORKER_MALE_HANDS_COWER_3 = 1807,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CAR_COLLISION_1 = 1808,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CAR_COLLISION_2 = 1809,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CAR_COLLISION_3 = 1810,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CAR_COLLISION_4 = 1811,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CAR_COLLISION_5 = 1812,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CHAT_1 = 1813,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CHAT_2 = 1814,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CHAT_3 = 1815,
	AUDIO_SAMPLE_PED_STEWARD_MALE_CHAT_4 = 1816,
	AUDIO_SAMPLE_PED_STEWARD_MALE_EVADE_1 = 1817,
	AUDIO_SAMPLE_PED_STEWARD_MALE_EVADE_2 = 1818,
	AUDIO_SAMPLE_PED_STEWARD_MALE_EVADE_3 = 1819,
	AUDIO_SAMPLE_PED_STEWARD_MALE_ATTACK_1 = 1820,
	AUDIO_SAMPLE_PED_STEWARD_MALE_ATTACK_2 = 1821,
	AUDIO_SAMPLE_PED_STEWARD_MALE_ATTACK_3 = 1822,
	AUDIO_SAMPLE_PED_STEWARD_MALE_ATTACK_4 = 1823,
	AUDIO_SAMPLE_PED_STEWARD_MALE_HANDS_COWER_1 = 1824,
	AUDIO_SAMPLE_PED_STEWARD_MALE_HANDS_COWER_2 = 1825,
	AUDIO_SAMPLE_PED_STEWARD_MALE_HANDS_COWER_3 = 1826,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CAR_COLLISION_1 = 1827,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CAR_COLLISION_2 = 1828,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CAR_COLLISION_3 = 1829,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CAR_COLLISION_4 = 1830,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CAR_COLLISION_5 = 1831,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CHAT_1 = 1832,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CHAT_2 = 1833,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CHAT_3 = 1834,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CHAT_4 = 1835,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_CHAT_5 = 1836,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_EVADE_1 = 1837,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_EVADE_2 = 1838,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_EVADE_3 = 1839,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_EVADE_4 = 1840,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_EVADE_5 = 1841,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_HANDS_COWER_1 = 1842,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_HANDS_COWER_2 = 1843,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_1_HANDS_COWER_3 = 1844,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CAR_COLLISION_1 = 1845,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CAR_COLLISION_2 = 1846,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CAR_COLLISION_3 = 1847,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CAR_COLLISION_4 = 1848,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CAR_COLLISION_5 = 1849,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CHAT_1 = 1850,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CHAT_2 = 1851,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CHAT_3 = 1852,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CHAT_4 = 1853,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_CHAT_5 = 1854,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_EVADE_1 = 1855,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_EVADE_2 = 1856,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_EVADE_3 = 1857,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_EVADE_4 = 1858,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_EVADE_5 = 1859,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_HANDS_COWER_1 = 1860,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_HANDS_COWER_2 = 1861,
	AUDIO_SAMPLE_PED_STEWARD_FEMALE_2_HANDS_COWER_3 = 1862,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_1 = 1863,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_2 = 1864,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_3 = 1865,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_4 = 1866,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_5 = 1867,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_COLLISION_6 = 1868,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_1 = 1869,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_2 = 1870,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_3 = 1871,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_4 = 1872,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_5 = 1873,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_6 = 1874,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_7 = 1875,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_1 = 1876,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_2 = 1877,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_3 = 1878,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_4 = 1879,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_5 = 1880,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_EVADE_6 = 1881,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_SEXY_1 = 1882,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_SEXY_2 = 1883,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CHAT_SEXY_3 = 1884,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_ATTACK_1 = 1885,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_ATTACK_2 = 1886,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_ATTACK_3 = 1887,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_ATTACK_4 = 1888,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_ATTACK_5 = 1889,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_HANDS_COWER_1 = 1890,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_HANDS_COWER_2 = 1891,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_HANDS_COWER_3 = 1892,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_JACKED_1 = 1893,
	AUDIO_SAMPLE_PED_CHINATOWN_MALE_OLD_CAR_JACKED_2 = 1894,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_COLLISION_1 = 1895,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_COLLISION_2 = 1896,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_COLLISION_3 = 1897,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_COLLISION_4 = 1898,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_COLLISION_5 = 1899,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_1 = 1900,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_2 = 1901,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_3 = 1902,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_4 = 1903,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_5 = 1904,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_6 = 1905,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_7 = 1906,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_1 = 1907,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_2 = 1908,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_3 = 1909,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_4 = 1910,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_5 = 1911,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_EVADE_6 = 1912,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_HANDS_COWER_1 = 1913,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_HANDS_COWER_2 = 1914,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_HANDS_COWER_3 = 1915,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_HANDS_COWER_4 = 1916,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_JACKED_1 = 1917,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CAR_JACKED_2 = 1918,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_ROBBED_1 = 1919,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_ROBBED_2 = 1920,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_FLEE_RUN_1 = 1921,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_FLEE_RUN_2 = 1922,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_FLEE_RUN_3 = 1923,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_FLEE_RUN_4 = 1924,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_EVENT_1 = 1925,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_EVENT_2 = 1926,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_EVENT_3 = 1927,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_1_CHAT_EVENT_4 = 1928,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_COLLISION_1 = 1929,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_COLLISION_2 = 1930,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_COLLISION_3 = 1931,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_COLLISION_4 = 1932,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_COLLISION_5 = 1933,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_1 = 1934,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_2 = 1935,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_3 = 1936,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_4 = 1937,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_5 = 1938,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_6 = 1939,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_7 = 1940,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_1 = 1941,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_2 = 1942,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_3 = 1943,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_4 = 1944,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_5 = 1945,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_EVADE_6 = 1946,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_HANDS_COWER_1 = 1947,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_HANDS_COWER_2 = 1948,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_HANDS_COWER_3 = 1949,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_HANDS_COWER_4 = 1950,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_JACKED_1 = 1951,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CAR_JACKED_2 = 1952,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_ROBBED_1 = 1953,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_ROBBED_2 = 1954,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_FLEE_RUN_1 = 1955,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_FLEE_RUN_2 = 1956,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_FLEE_RUN_3 = 1957,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_FLEE_RUN_4 = 1958,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_EVENT_1 = 1959,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_EVENT_2 = 1960,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_EVENT_3 = 1961,
	AUDIO_SAMPLE_PED_BUSINESS_WOMAN_2_CHAT_EVENT_4 = 1962,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_1 = 1963,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_2 = 1964,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_3 = 1965,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_4 = 1966,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_5 = 1967,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_COLLISION_6 = 1968,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_1 = 1969,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_2 = 1970,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_3 = 1971,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_4 = 1972,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_5 = 1973,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_6 = 1974,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_7 = 1975,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CHAT_8 = 1976,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_1 = 1977,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_2 = 1978,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_3 = 1979,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_4 = 1980,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_5 = 1981,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_6 = 1982,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_EVADE_7 = 1983,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_JACKED_1 = 1984,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_JACKED_2 = 1985,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_JACKED_3 = 1986,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_CAR_JACKED_4 = 1987,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_WAIT_DOUBLEBACK_1 = 1988,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_WAIT_DOUBLEBACK_2 = 1989,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_WAIT_DOUBLEBACK_3 = 1990,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_ROBBED_1 = 1991,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_ROBBED_2 = 1992,
	AUDIO_SAMPLE_PED_BLACK_FAT_MALE_1_ROBBED_3 = 1993,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_1 = 1994,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_2 = 1995,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_3 = 1996,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_4 = 1997,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_5 = 1998,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_6 = 1999,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_COLLISION_7 = 2000,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_1 = 2001,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_2 = 2002,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_3 = 2003,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_4 = 2004,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_5 = 2005,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_6 = 2006,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_EVADE_1 = 2007,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_EVADE_2 = 2008,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_EVADE_3 = 2009,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_EVADE_4 = 2010,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_EVADE_5 = 2011,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_SEXY_1 = 2012,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_SEXY_2 = 2013,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CHAT_SEXY_3 = 2014,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_1 = 2015,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_2 = 2016,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_3 = 2017,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_4 = 2018,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_5 = 2019,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ATTACK_6 = 2020,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_HANDS_UP_1 = 2021,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_HANDS_UP_2 = 2022,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_HANDS_UP_3 = 2023,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_JACKED_1 = 2024,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_CAR_JACKED_2 = 2025,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ROBBED_1 = 2026,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_1_ROBBED_2 = 2027,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_1 = 2028,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_2 = 2029,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_3 = 2030,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_4 = 2031,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_5 = 2032,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_6 = 2033,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_COLLISION_7 = 2034,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_1 = 2035,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_2 = 2036,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_3 = 2037,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_4 = 2038,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_5 = 2039,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_6 = 2040,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_EVADE_1 = 2041,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_EVADE_2 = 2042,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_EVADE_3 = 2043,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_EVADE_4 = 2044,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_EVADE_5 = 2045,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_SEXY_1 = 2046,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_SEXY_2 = 2047,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CHAT_SEXY_3 = 2048,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_1 = 2049,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_2 = 2050,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_3 = 2051,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_4 = 2052,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_5 = 2053,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ATTACK_6 = 2054,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_HANDS_UP_1 = 2055,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_HANDS_UP_2 = 2056,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_HANDS_UP_3 = 2057,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_JACKED_1 = 2058,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_CAR_JACKED_2 = 2059,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ROBBED_1 = 2060,
	AUDIO_SAMPLE_PED_BLACK_PROJECT_MALE_2_ROBBED_2 = 2061,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CAR_COLLISION_1 = 2062,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CAR_COLLISION_2 = 2063,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CAR_COLLISION_3 = 2064,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CAR_COLLISION_4 = 2065,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_1 = 2066,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_2 = 2067,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_3 = 2068,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_4 = 2069,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_EVADE_1 = 2070,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_EVADE_2 = 2071,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_EVADE_3 = 2072,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_SEXY_1 = 2073,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_SEXY_2 = 2074,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_CHAT_SEXY_3 = 2075,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_ATTACK_1 = 2076,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_ATTACK_2 = 2077,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_ATTACK_3 = 2078,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_HANDS_COWER_1 = 2079,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_HANDS_COWER_2 = 2080,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_HANDS_COWER_3 = 2081,
	AUDIO_SAMPLE_PED_BLACK_WORKER_MALE_HANDS_COWER_4 = 2082,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_1 = 2083,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_2 = 2084,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_3 = 2085,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_4 = 2086,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_5 = 2087,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_6 = 2088,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_COLLISION_7 = 2089,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_1 = 2090,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_2 = 2091,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_3 = 2092,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_4 = 2093,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_5 = 2094,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_6 = 2095,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_7 = 2096,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_1 = 2097,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_2 = 2098,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_3 = 2099,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_4 = 2100,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_5 = 2101,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_EVADE_6 = 2102,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_JACKED_1 = 2103,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CAR_JACKED_2 = 2104,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_ROBBED_1 = 2105,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_ROBBED_2 = 2106,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_EVENT_1 = 2107,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_EVENT_2 = 2108,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_EVENT_3 = 2109,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_1_CHAT_EVENT_4 = 2110,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_1 = 2111,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_2 = 2112,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_3 = 2113,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_4 = 2114,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_5 = 2115,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_6 = 2116,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_COLLISION_7 = 2117,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_1 = 2118,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_2 = 2119,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_3 = 2120,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_4 = 2121,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_5 = 2122,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_6 = 2123,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_7 = 2124,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_1 = 2125,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_2 = 2126,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_3 = 2127,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_4 = 2128,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_5 = 2129,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_EVADE_6 = 2130,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_JACKED_1 = 2131,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CAR_JACKED_2 = 2132,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_ROBBED_1 = 2133,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_ROBBED_2 = 2134,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_EVENT_1 = 2135,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_EVENT_2 = 2136,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_EVENT_3 = 2137,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_2_CHAT_EVENT_4 = 2138,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_1 = 2139,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_2 = 2140,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_3 = 2141,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_4 = 2142,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_5 = 2143,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_6 = 2144,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_COLLISION_7 = 2145,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_1 = 2146,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_2 = 2147,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_3 = 2148,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_4 = 2149,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_5 = 2150,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_6 = 2151,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_7 = 2152,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_1 = 2153,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_2 = 2154,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_3 = 2155,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_4 = 2156,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_5 = 2157,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_EVADE_6 = 2158,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_JACKED_1 = 2159,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CAR_JACKED_2 = 2160,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_ROBBED_1 = 2161,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_ROBBED_2 = 2162,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_EVENT_1 = 2163,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_EVENT_2 = 2164,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_EVENT_3 = 2165,
	AUDIO_SAMPLE_PED_SHOPPER_FEMALE_3_CHAT_EVENT_4 = 2166,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_1 = 2167,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_2 = 2168,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_3 = 2169,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_4 = 2170,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_5 = 2171,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_COLLISION_6 = 2172,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_1 = 2173,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_2 = 2174,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_3 = 2175,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_4 = 2176,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_5 = 2177,
	AUDIO_SAMPLE_PED_COLUMB_1_EVADE_1 = 2178,
	AUDIO_SAMPLE_PED_COLUMB_1_EVADE_2 = 2179,
	AUDIO_SAMPLE_PED_COLUMB_1_EVADE_3 = 2180,
	AUDIO_SAMPLE_PED_COLUMB_1_EVADE_4 = 2181,
	AUDIO_SAMPLE_PED_COLUMB_1_EVADE_5 = 2182,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_SEXY_1 = 2183,
	AUDIO_SAMPLE_PED_COLUMB_1_CHAT_SEXY_2 = 2184,
	AUDIO_SAMPLE_PED_COLUMB_1_ATTACK_1 = 2185,
	AUDIO_SAMPLE_PED_COLUMB_1_ATTACK_2 = 2186,
	AUDIO_SAMPLE_PED_COLUMB_1_ATTACK_3 = 2187,
	AUDIO_SAMPLE_PED_COLUMB_1_ATTACK_4 = 2188,
	AUDIO_SAMPLE_PED_COLUMB_1_ATTACK_5 = 2189,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_JACKED_1 = 2190,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_JACKED_2 = 2191,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_JACKING_1 = 2192,
	AUDIO_SAMPLE_PED_COLUMB_1_CAR_JACKING_2 = 2193,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_1 = 2194,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_2 = 2195,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_3 = 2196,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_4 = 2197,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_5 = 2198,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_COLLISION_6 = 2199,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_1 = 2200,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_2 = 2201,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_3 = 2202,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_4 = 2203,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_5 = 2204,
	AUDIO_SAMPLE_PED_COLUMB_2_EVADE_1 = 2205,
	AUDIO_SAMPLE_PED_COLUMB_2_EVADE_2 = 2206,
	AUDIO_SAMPLE_PED_COLUMB_2_EVADE_3 = 2207,
	AUDIO_SAMPLE_PED_COLUMB_2_EVADE_4 = 2208,
	AUDIO_SAMPLE_PED_COLUMB_2_EVADE_5 = 2209,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_SEXY_1 = 2210,
	AUDIO_SAMPLE_PED_COLUMB_2_CHAT_SEXY_2 = 2211,
	AUDIO_SAMPLE_PED_COLUMB_2_ATTACK_1 = 2212,
	AUDIO_SAMPLE_PED_COLUMB_2_ATTACK_2 = 2213,
	AUDIO_SAMPLE_PED_COLUMB_2_ATTACK_3 = 2214,
	AUDIO_SAMPLE_PED_COLUMB_2_ATTACK_4 = 2215,
	AUDIO_SAMPLE_PED_COLUMB_2_ATTACK_5 = 2216,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_JACKED_1 = 2217,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_JACKED_2 = 2218,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_JACKING_1 = 2219,
	AUDIO_SAMPLE_PED_COLUMB_2_CAR_JACKING_2 = 2220,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_1 = 2221,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_2 = 2222,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_3 = 2223,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_4 = 2224,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_5 = 2225,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_6 = 2226,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_COLLISION_7 = 2227,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_1 = 2228,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_2 = 2229,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_3 = 2230,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_4 = 2231,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_5 = 2232,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_6 = 2233,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_7 = 2234,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_1 = 2235,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_2 = 2236,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_3 = 2237,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_4 = 2238,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_5 = 2239,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_EVADE_6 = 2240,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_JACKED_1 = 2241,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CAR_JACKED_2 = 2242,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_ROBBED_1 = 2243,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_ROBBED_2 = 2244,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_EVENT_1 = 2245,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_EVENT_2 = 2246,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_EVENT_3 = 2247,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_YOUNG_CHAT_EVENT_4 = 2248,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CAR_COLLISION_1 = 2249,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CAR_COLLISION_2 = 2250,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CAR_COLLISION_3 = 2251,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CAR_COLLISION_4 = 2252,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CAR_COLLISION_5 = 2253,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_1 = 2254,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_2 = 2255,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_3 = 2256,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_4 = 2257,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_5 = 2258,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_6 = 2259,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_EVADE_1 = 2260,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_EVADE_2 = 2261,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_EVADE_3 = 2262,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_EVADE_4 = 2263,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_EVADE_5 = 2264,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_HANDS_COWER_1 = 2265,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_HANDS_COWER_2 = 2266,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_HANDS_COWER_3 = 2267,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_ROBBED_1 = 2268,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_ROBBED_2 = 2269,
	AUDIO_SAMPLE_PED_CHINATOWN_FEMALE_OLD_CHAT_EVENT_1 = 2270,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_1 = 2271,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_2 = 2272,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_3 = 2273,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_4 = 2274,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_5 = 2275,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_6 = 2276,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_7 = 2277,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_8 = 2278,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_9 = 2279,
	AUDIO_SAMPLE_PED_FEMALE_DEATH_10 = 2280,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_1 = 2281,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_2 = 2282,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_3 = 2283,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_4 = 2284,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_5 = 2285,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_6 = 2286,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_7 = 2287,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_8 = 2288,
	AUDIO_SAMPLE_PED_FEMALE_BURNING_9 = 2289,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_1 = 2290,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_2 = 2291,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_3 = 2292,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_4 = 2293,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_5 = 2294,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_6 = 2295,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_7 = 2296,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_8 = 2297,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_9 = 2298,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_10 = 2299,
	AUDIO_SAMPLE_INJURED_PED_FEMALE_OUCH_11 = 2300,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_1 = 2301,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_2 = 2302,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_3 = 2303,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_4 = 2304,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_5 = 2305,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_6 = 2306,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_7 = 2307,
	AUDIO_SAMPLE_PED_FEMALE_FLEE_SPRINT_8 = 2308,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_COLLISION_1 = 2309,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_COLLISION_2 = 2310,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_COLLISION_3 = 2311,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_COLLISION_4 = 2312,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_COLLISION_5 = 2313,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_1 = 2314,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_2 = 2315,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_3 = 2316,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_4 = 2317,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_5 = 2318,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_EVADE_6 = 2319,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_ATTACK_1 = 2320,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_ATTACK_2 = 2321,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_ATTACK_3 = 2322,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_ATTACK_4 = 2323,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_ATTACK_5 = 2324,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_HANDS_UP_1 = 2325,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_HANDS_UP_2 = 2326,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_HANDS_UP_3 = 2327,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_HANDS_UP_4 = 2328,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_CAR_JACKING_1 = 2329,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_MUGGING_1 = 2330,
	AUDIO_SAMPLE_PED_BLACK_CRIMINAL_1_MUGGING_2 = 2331,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_CAR_COLLISION_1 = 2332,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_CAR_COLLISION_2 = 2333,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_CAR_COLLISION_3 = 2334,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_CAR_COLLISION_4 = 2335,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_EVADE_1 = 2336,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_EVADE_2 = 2337,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_EVADE_3 = 2338,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_EVADE_4 = 2339,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_EVADE_5 = 2340,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_ATTACK_1 = 2341,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_ATTACK_2 = 2342,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_ATTACK_3 = 2343,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_ATTACK_4 = 2344,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_HANDS_UP_1 = 2345,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_HANDS_UP_2 = 2346,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_HANDS_UP_3 = 2347,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_CAR_JACKING_1 = 2348,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_MUGGING_1 = 2349,
	AUDIO_SAMPLE_PED_WHITE_CRIMINAL_1_MUGGING_2 = 2350,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_COLLISION_1 = 2351,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_COLLISION_2 = 2352,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_COLLISION_3 = 2353,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_COLLISION_4 = 2354,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_COLLISION_5 = 2355,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CHAT_1 = 2356,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CHAT_2 = 2357,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CHAT_3 = 2358,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CHAT_4 = 2359,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CHAT_5 = 2360,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_EVADE_1 = 2361,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_EVADE_2 = 2362,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_EVADE_3 = 2363,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_EVADE_4 = 2364,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ATTACK_1 = 2365,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ATTACK_2 = 2366,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ATTACK_3 = 2367,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ATTACK_4 = 2368,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ATTACK_5 = 2369,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_HANDS_COWER_1 = 2370,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_HANDS_COWER_2 = 2371,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_HANDS_COWER_3 = 2372,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_JACKED_1 = 2373,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_CAR_JACKED_2 = 2374,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ROBBED_1 = 2375,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_ROBBED_2 = 2376,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_FLEE_RUN_1 = 2377,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_FLEE_RUN_2 = 2378,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_FLEE_RUN_3 = 2379,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_FLEE_RUN_4 = 2380,
	AUDIO_SAMPLE_PED_BUSINESS_MALE_OLD_1_FLEE_RUN_5 = 2381,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_1 = 2382,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_2 = 2383,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_3 = 2384,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_4 = 2385,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_5 = 2386,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_6 = 2387,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_COLLISION_7 = 2388,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_1 = 2389,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_2 = 2390,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_3 = 2391,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_4 = 2392,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_5 = 2393,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CHAT_6 = 2394,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_EVADE_1 = 2395,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_EVADE_2 = 2396,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_EVADE_3 = 2397,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_EVADE_4 = 2398,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_EVADE_5 = 2399,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ATTACK_1 = 2400,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ATTACK_2 = 2401,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ATTACK_3 = 2402,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ATTACK_4 = 2403,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ATTACK_5 = 2404,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_HANDS_COWER_1 = 2405,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_HANDS_COWER_2 = 2406,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_HANDS_COWER_3 = 2407,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_JACKED_1 = 2408,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_CAR_JACKED_2 = 2409,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ROBBED_1 = 2410,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_1_ROBBED_2 = 2411,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_1 = 2412,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_2 = 2413,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_3 = 2414,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_4 = 2415,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_5 = 2416,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_6 = 2417,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_COLLISION_7 = 2418,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_1 = 2419,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_2 = 2420,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_3 = 2421,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_4 = 2422,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_5 = 2423,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CHAT_6 = 2424,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_EVADE_1 = 2425,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_EVADE_2 = 2426,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_EVADE_3 = 2427,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_EVADE_4 = 2428,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_EVADE_5 = 2429,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ATTACK_1 = 2430,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ATTACK_2 = 2431,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ATTACK_3 = 2432,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ATTACK_4 = 2433,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ATTACK_5 = 2434,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_HANDS_COWER_1 = 2435,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_HANDS_COWER_2 = 2436,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_HANDS_COWER_3 = 2437,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_JACKED_1 = 2438,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_CAR_JACKED_2 = 2439,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ROBBED_1 = 2440,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_MALE_2_ROBBED_2 = 2441,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_1 = 2442,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_2 = 2443,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_3 = 2444,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_4 = 2445,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_5 = 2446,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_6 = 2447,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_COLLISION_7 = 2448,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_1 = 2449,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_2 = 2450,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_3 = 2451,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_4 = 2452,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_5 = 2453,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_6 = 2454,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_7 = 2455,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_8 = 2456,
	AUDIO_SAMPLE_PED_TRIAD_1_EVADE_1 = 2457,
	AUDIO_SAMPLE_PED_TRIAD_1_EVADE_2 = 2458,
	AUDIO_SAMPLE_PED_TRIAD_1_EVADE_3 = 2459,
	AUDIO_SAMPLE_PED_TRIAD_1_EVADE_4 = 2460,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_SEXY_1 = 2461,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_SEXY_2 = 2462,
	AUDIO_SAMPLE_PED_TRIAD_1_CHAT_SEXY_3 = 2463,
	AUDIO_SAMPLE_PED_TRIAD_1_ATTACK_1 = 2464,
	AUDIO_SAMPLE_PED_TRIAD_1_ATTACK_2 = 2465,
	AUDIO_SAMPLE_PED_TRIAD_1_ATTACK_3 = 2466,
	AUDIO_SAMPLE_PED_TRIAD_1_ATTACK_4 = 2467,
	AUDIO_SAMPLE_PED_TRIAD_1_ATTACK_5 = 2468,
	AUDIO_SAMPLE_PED_TRIAD_1_HANDS_UP_1 = 2469,
	AUDIO_SAMPLE_PED_TRIAD_1_HANDS_UP_2 = 2470,
	AUDIO_SAMPLE_PED_TRIAD_1_HANDS_UP_3 = 2471,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_JACKED_1 = 2472,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_JACKED_2 = 2473,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_JACKING_1 = 2474,
	AUDIO_SAMPLE_PED_TRIAD_1_CAR_JACKING_2 = 2475,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_1 = 2476,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_2 = 2477,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_3 = 2478,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_4 = 2479,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_5 = 2480,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_COLLISION_6 = 2481,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_1 = 2482,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_2 = 2483,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_3 = 2484,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_4 = 2485,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_5 = 2486,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_6 = 2487,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_7 = 2488,
	AUDIO_SAMPLE_PED_MAFIA_1_EVADE_1 = 2489,
	AUDIO_SAMPLE_PED_MAFIA_1_EVADE_2 = 2490,
	AUDIO_SAMPLE_PED_MAFIA_1_EVADE_3 = 2491,
	AUDIO_SAMPLE_PED_MAFIA_1_EVADE_4 = 2492,
	AUDIO_SAMPLE_PED_MAFIA_1_EVADE_5 = 2493,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_SEXY_1 = 2494,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_SEXY_2 = 2495,
	AUDIO_SAMPLE_PED_MAFIA_1_CHAT_SEXY_3 = 2496,
	AUDIO_SAMPLE_PED_MAFIA_1_ATTACK_1 = 2497,
	AUDIO_SAMPLE_PED_MAFIA_1_ATTACK_2 = 2498,
	AUDIO_SAMPLE_PED_MAFIA_1_ATTACK_3 = 2499,
	AUDIO_SAMPLE_PED_MAFIA_1_ATTACK_4 = 2500,
	AUDIO_SAMPLE_PED_MAFIA_1_ATTACK_5 = 2501,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_JACKED_1 = 2502,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_JACKED_2 = 2503,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_JACKING_1 = 2504,
	AUDIO_SAMPLE_PED_MAFIA_1_CAR_JACKING_2 = 2505,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_1 = 2506,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_2 = 2507,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_3 = 2508,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_4 = 2509,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_5 = 2510,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_COLLISION_6 = 2511,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_1 = 2512,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_2 = 2513,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_3 = 2514,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_4 = 2515,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_5 = 2516,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_6 = 2517,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_7 = 2518,
	AUDIO_SAMPLE_PED_MAFIA_2_EVADE_1 = 2519,
	AUDIO_SAMPLE_PED_MAFIA_2_EVADE_2 = 2520,
	AUDIO_SAMPLE_PED_MAFIA_2_EVADE_3 = 2521,
	AUDIO_SAMPLE_PED_MAFIA_2_EVADE_4 = 2522,
	AUDIO_SAMPLE_PED_MAFIA_2_EVADE_5 = 2523,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_SEXY_1 = 2524,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_SEXY_2 = 2525,
	AUDIO_SAMPLE_PED_MAFIA_2_CHAT_SEXY_3 = 2526,
	AUDIO_SAMPLE_PED_MAFIA_2_ATTACK_1 = 2527,
	AUDIO_SAMPLE_PED_MAFIA_2_ATTACK_2 = 2528,
	AUDIO_SAMPLE_PED_MAFIA_2_ATTACK_3 = 2529,
	AUDIO_SAMPLE_PED_MAFIA_2_ATTACK_4 = 2530,
	AUDIO_SAMPLE_PED_MAFIA_2_ATTACK_5 = 2531,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_JACKED_1 = 2532,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_JACKED_2 = 2533,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_JACKING_1 = 2534,
	AUDIO_SAMPLE_PED_MAFIA_2_CAR_JACKING_2 = 2535,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_1 = 2536,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_2 = 2537,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_3 = 2538,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_4 = 2539,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_5 = 2540,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_COLLISION_6 = 2541,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_1 = 2542,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_2 = 2543,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_3 = 2544,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_4 = 2545,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_5 = 2546,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_6 = 2547,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_7 = 2548,
	AUDIO_SAMPLE_PED_MAFIA_3_EVADE_1 = 2549,
	AUDIO_SAMPLE_PED_MAFIA_3_EVADE_2 = 2550,
	AUDIO_SAMPLE_PED_MAFIA_3_EVADE_3 = 2551,
	AUDIO_SAMPLE_PED_MAFIA_3_EVADE_4 = 2552,
	AUDIO_SAMPLE_PED_MAFIA_3_EVADE_5 = 2553,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_SEXY_1 = 2554,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_SEXY_2 = 2555,
	AUDIO_SAMPLE_PED_MAFIA_3_CHAT_SEXY_3 = 2556,
	AUDIO_SAMPLE_PED_MAFIA_3_ATTACK_1 = 2557,
	AUDIO_SAMPLE_PED_MAFIA_3_ATTACK_2 = 2558,
	AUDIO_SAMPLE_PED_MAFIA_3_ATTACK_3 = 2559,
	AUDIO_SAMPLE_PED_MAFIA_3_ATTACK_4 = 2560,
	AUDIO_SAMPLE_PED_MAFIA_3_ATTACK_5 = 2561,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_JACKED_1 = 2562,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_JACKED_2 = 2563,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_JACKING_1 = 2564,
	AUDIO_SAMPLE_PED_MAFIA_3_CAR_JACKING_2 = 2565,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_1 = 2566,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_2 = 2567,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_3 = 2568,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_4 = 2569,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_5 = 2570,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_COLLISION_6 = 2571,
	AUDIO_SAMPLE_PED_YAKUZA_1_CHAT_1 = 2572,
	AUDIO_SAMPLE_PED_YAKUZA_1_CHAT_2 = 2573,
	AUDIO_SAMPLE_PED_YAKUZA_1_CHAT_3 = 2574,
	AUDIO_SAMPLE_PED_YAKUZA_1_CHAT_4 = 2575,
	AUDIO_SAMPLE_PED_YAKUZA_1_CHAT_5 = 2576,
	AUDIO_SAMPLE_PED_YAKUZA_1_EVADE_1 = 2577,
	AUDIO_SAMPLE_PED_YAKUZA_1_EVADE_2 = 2578,
	AUDIO_SAMPLE_PED_YAKUZA_1_EVADE_3 = 2579,
	AUDIO_SAMPLE_PED_YAKUZA_1_EVADE_4 = 2580,
	AUDIO_SAMPLE_PED_YAKUZA_1_ATTACK_1 = 2581,
	AUDIO_SAMPLE_PED_YAKUZA_1_ATTACK_2 = 2582,
	AUDIO_SAMPLE_PED_YAKUZA_1_ATTACK_3 = 2583,
	AUDIO_SAMPLE_PED_YAKUZA_1_ATTACK_4 = 2584,
	AUDIO_SAMPLE_PED_YAKUZA_1_ATTACK_5 = 2585,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_JACKED_1 = 2586,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_JACKED_2 = 2587,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_JACKING_1 = 2588,
	AUDIO_SAMPLE_PED_YAKUZA_1_CAR_JACKING_2 = 2589,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_1 = 2590,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_2 = 2591,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_3 = 2592,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_4 = 2593,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_5 = 2594,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_COLLISION_6 = 2595,
	AUDIO_SAMPLE_PED_YAKUZA_2_CHAT_1 = 2596,
	AUDIO_SAMPLE_PED_YAKUZA_2_CHAT_2 = 2597,
	AUDIO_SAMPLE_PED_YAKUZA_2_CHAT_3 = 2598,
	AUDIO_SAMPLE_PED_YAKUZA_2_CHAT_4 = 2599,
	AUDIO_SAMPLE_PED_YAKUZA_2_CHAT_5 = 2600,
	AUDIO_SAMPLE_PED_YAKUZA_2_EVADE_1 = 2601,
	AUDIO_SAMPLE_PED_YAKUZA_2_EVADE_2 = 2602,
	AUDIO_SAMPLE_PED_YAKUZA_2_EVADE_3 = 2603,
	AUDIO_SAMPLE_PED_YAKUZA_2_EVADE_4 = 2604,
	AUDIO_SAMPLE_PED_YAKUZA_2_ATTACK_1 = 2605,
	AUDIO_SAMPLE_PED_YAKUZA_2_ATTACK_2 = 2606,
	AUDIO_SAMPLE_PED_YAKUZA_2_ATTACK_3 = 2607,
	AUDIO_SAMPLE_PED_YAKUZA_2_ATTACK_4 = 2608,
	AUDIO_SAMPLE_PED_YAKUZA_2_ATTACK_5 = 2609,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_JACKED_1 = 2610,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_JACKED_2 = 2611,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_JACKING_1 = 2612,
	AUDIO_SAMPLE_PED_YAKUZA_2_CAR_JACKING_2 = 2613,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CAR_COLLISION_1 = 2614,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CAR_COLLISION_2 = 2615,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CAR_COLLISION_3 = 2616,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CAR_COLLISION_4 = 2617,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_1 = 2618,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_2 = 2619,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_3 = 2620,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_4 = 2621,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_5 = 2622,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_6 = 2623,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_7 = 2624,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_EVADE_1 = 2625,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_EVADE_2 = 2626,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_EVADE_3 = 2627,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_EVADE_4 = 2628,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_EVADE_5 = 2629,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_SEXY_1 = 2630,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_SEXY_2 = 2631,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CHAT_SEXY_3 = 2632,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_ATTACK_1 = 2633,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_ATTACK_2 = 2634,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_ATTACK_3 = 2635,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_ATTACK_4 = 2636,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_ATTACK_5 = 2637,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_HANDS_COWER_1 = 2638,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_HANDS_COWER_2 = 2639,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_HANDS_COWER_3 = 2640,
	AUDIO_SAMPLE_PED_WHITE_CONSTRUCTION_WORKER_CAR_JACKED_1 = 2641,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_1 = 2642,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_2 = 2643,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_3 = 2644,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_4 = 2645,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_5 = 2646,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_COLLISION_6 = 2647,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_1 = 2648,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_2 = 2649,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_3 = 2650,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_4 = 2651,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_5 = 2652,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_6 = 2653,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_1_CAR_JACKED_7 = 2654,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_1 = 2655,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_2 = 2656,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_3 = 2657,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_4 = 2658,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_5 = 2659,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_COLLISION_6 = 2660,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_1 = 2661,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_2 = 2662,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_3 = 2663,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_4 = 2664,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_5 = 2665,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_6 = 2666,
	AUDIO_SAMPLE_PED_TAXI_DRIVER_2_CAR_JACKED_7 = 2667,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_1 = 2668,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_2 = 2669,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_3 = 2670,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_4 = 2671,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_5 = 2672,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_CAR_EVENT_6 = 2673,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_ATTACK_1 = 2674,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_ATTACK_2 = 2675,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_HANDS_UP_1 = 2676,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_HANDS_UP_2 = 2677,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_HANDS_COWER_1 = 2678,
	AUDIO_SAMPLE_PED_SECURITY_GUARD_FLEE_RUN_1 = 2679,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CHAT_1 = 2680,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CHAT_2 = 2681,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CHAT_3 = 2682,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CHAT_4 = 2683,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_EVADE_1 = 2684,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_EVADE_2 = 2685,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_EVADE_3 = 2686,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_ROBBED_1 = 2687,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CAR_COLLISION_1 = 2688,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CAR_COLLISION_2 = 2689,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CAR_COLLISION_3 = 2690,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_CAR_COLLISION_4 = 2691,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_ATTACK_1 = 2692,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_ATTACK_2 = 2693,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_ATTACK_3 = 2694,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_ATTACK_4 = 2695,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_1 = 2696,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_2 = 2697,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_3 = 2698,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_4 = 2699,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_5 = 2700,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_6 = 2701,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_7 = 2702,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_SOLICIT_8 = 2703,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_HANDS_UP_1 = 2704,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_HANDS_UP_2 = 2705,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_HANDS_UP_3 = 2706,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_1_HANDS_UP_4 = 2707,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CHAT_1 = 2708,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CHAT_2 = 2709,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CHAT_3 = 2710,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CHAT_4 = 2711,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_EVADE_1 = 2712,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_EVADE_2 = 2713,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_EVADE_3 = 2714,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_ROBBED_1 = 2715,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CAR_COLLISION_1 = 2716,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CAR_COLLISION_2 = 2717,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CAR_COLLISION_3 = 2718,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_CAR_COLLISION_4 = 2719,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_ATTACK_1 = 2720,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_ATTACK_2 = 2721,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_ATTACK_3 = 2722,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_ATTACK_4 = 2723,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_1 = 2724,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_2 = 2725,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_3 = 2726,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_4 = 2727,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_5 = 2728,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_6 = 2729,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_7 = 2730,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_SOLICIT_8 = 2731,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_HANDS_UP_1 = 2732,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_HANDS_UP_2 = 2733,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_HANDS_UP_3 = 2734,
	AUDIO_SAMPLE_PED_BLACK_FEMALE_PROSTITUTE_2_HANDS_UP_4 = 2735,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CHAT_1 = 2736,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CHAT_2 = 2737,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CHAT_3 = 2738,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CHAT_4 = 2739,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_EVADE_1 = 2740,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_EVADE_2 = 2741,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_EVADE_3 = 2742,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ROBBED_1 = 2743,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ROBBED_2 = 2744,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CAR_COLLISION_1 = 2745,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CAR_COLLISION_2 = 2746,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CAR_COLLISION_3 = 2747,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_CAR_COLLISION_4 = 2748,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ATTACK_1 = 2749,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ATTACK_2 = 2750,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ATTACK_3 = 2751,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_ATTACK_4 = 2752,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_1 = 2753,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_2 = 2754,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_3 = 2755,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_4 = 2756,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_5 = 2757,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_6 = 2758,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_7 = 2759,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_1_SOLICIT_8 = 2760,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CHAT_1 = 2761,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CHAT_2 = 2762,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CHAT_3 = 2763,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CHAT_4 = 2764,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_EVADE_1 = 2765,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_EVADE_2 = 2766,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_EVADE_3 = 2767,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ROBBED_1 = 2768,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ROBBED_2 = 2769,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CAR_COLLISION_1 = 2770,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CAR_COLLISION_2 = 2771,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CAR_COLLISION_3 = 2772,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_CAR_COLLISION_4 = 2773,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ATTACK_1 = 2774,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ATTACK_2 = 2775,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ATTACK_3 = 2776,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_ATTACK_4 = 2777,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_1 = 2778,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_2 = 2779,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_3 = 2780,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_4 = 2781,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_5 = 2782,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_6 = 2783,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_7 = 2784,
	AUDIO_SAMPLE_PED_WHITE_FEMALE_PROSTITUTE_2_SOLICIT_8 = 2785,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_1 = 2786,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_2 = 2787,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_3 = 2788,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_4 = 2789,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_5 = 2790,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_6 = 2791,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_1 = 2792,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_2 = 2793,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_3 = 2794,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_4 = 2795,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_5 = 2796,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_6 = 2797,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_EVADE_7 = 2798,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_JACKED_1 = 2799,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_JACKED_2 = 2800,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_ROBBED_1 = 2801,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_ROBBED_2 = 2802,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_1 = 2803,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_2 = 2804,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_3 = 2805,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_4 = 2806,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_5 = 2807,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CAR_COLLISION_6 = 2808,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_EVENT_1 = 2809,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_EVENT_2 = 2810,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_EVENT_3 = 2811,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_YOUNG_CHAT_EVENT_4 = 2812,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_1 = 2813,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_2 = 2814,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_3 = 2815,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_4 = 2816,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_5 = 2817,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_6 = 2818,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_7 = 2819,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_1 = 2820,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_2 = 2821,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_3 = 2822,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_4 = 2823,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_5 = 2824,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_EVADE_6 = 2825,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_JACKED_1 = 2826,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_JACKED_2 = 2827,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_ROBBED_1 = 2828,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_ROBBED_2 = 2829,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_1 = 2830,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_2 = 2831,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_3 = 2832,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_4 = 2833,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_5 = 2834,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_6 = 2835,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CAR_COLLISION_7 = 2836,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_EVENT_1 = 2837,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_EVENT_2 = 2838,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_EVENT_3 = 2839,
	AUDIO_SAMPLE_PED_LITTLE_ITALY_FEMALE_OLD_CHAT_EVENT_4 = 2840,
	AUDIO_SAMPLE_PED_MALE_DEATH_1 = 2841,
	AUDIO_SAMPLE_PED_MALE_DEATH_2 = 2842,
	AUDIO_SAMPLE_PED_MALE_DEATH_3 = 2843,
	AUDIO_SAMPLE_PED_MALE_DEATH_4 = 2844,
	AUDIO_SAMPLE_PED_MALE_DEATH_5 = 2845,
	AUDIO_SAMPLE_PED_MALE_DEATH_6 = 2846,
	AUDIO_SAMPLE_PED_MALE_DEATH_7 = 2847,
	AUDIO_SAMPLE_PED_MALE_DEATH_8 = 2848,
	AUDIO_SAMPLE_PED_MALE_BURNING_1 = 2849,
	AUDIO_SAMPLE_PED_MALE_BURNING_2 = 2850,
	AUDIO_SAMPLE_PED_MALE_BURNING_3 = 2851,
	AUDIO_SAMPLE_PED_MALE_BURNING_4 = 2852,
	AUDIO_SAMPLE_PED_MALE_BURNING_5 = 2853,
	AUDIO_SAMPLE_PED_MALE_BURNING_6 = 2854,
	AUDIO_SAMPLE_PED_MALE_BURNING_7 = 2855,
	AUDIO_SAMPLE_PED_MALE_BURNING_8 = 2856,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_1 = 2857,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_2 = 2858,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_3 = 2859,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_4 = 2860,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_5 = 2861,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_6 = 2862,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_7 = 2863,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_8 = 2864,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_9 = 2865,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_10 = 2866,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_11 = 2867,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_12 = 2868,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_13 = 2869,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_14 = 2870,
	AUDIO_SAMPLE_INJURED_PED_MALE_OUCH_15 = 2871,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_1 = 2872,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_2 = 2873,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_3 = 2874,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_4 = 2875,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_5 = 2876,
	AUDIO_SAMPLE_PED_MALE_FLEE_SPRINT_6 = 2877,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_1 = 2878,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_2 = 2879,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_3 = 2880,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_4 = 2881,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_5 = 2882,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_6 = 2883,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_7 = 2884,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_8 = 2885,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CHAT_9 = 2886,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_1 = 2887,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_2 = 2888,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_3 = 2889,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_4 = 2890,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_5 = 2891,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_6 = 2892,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_7 = 2893,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_8 = 2894,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_EVADE_9 = 2895,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_JACKED_1 = 2896,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_JACKED_2 = 2897,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_JACKED_3 = 2898,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_ROBBED_1 = 2899,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_ROBBED_2 = 2900,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_ROBBED_3 = 2901,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_WAIT_DOUBLEBACK_1 = 2902,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_WAIT_DOUBLEBACK_2 = 2903,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_1 = 2904,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_2 = 2905,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_3 = 2906,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_4 = 2907,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_5 = 2908,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_6 = 2909,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_7 = 2910,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_8 = 2911,
	AUDIO_SAMPLE_PED_WHITE_FAT_MALE_1_CAR_COLLISION_9 = 2912,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_1 = 2913,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_2 = 2914,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_3 = 2915,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_4 = 2916,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_5 = 2917,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_6 = 2918,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_7 = 2919,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_8 = 2920,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_1 = 2921,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_2 = 2922,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_3 = 2923,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_4 = 2924,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_5 = 2925,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_EVADE_6 = 2926,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_JACKED_1 = 2927,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_JACKED_2 = 2928,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_ROBBED_1 = 2929,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_ROBBED_2 = 2930,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_WAIT_DOUBLEBACK_1 = 2931,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_WAIT_DOUBLEBACK_2 = 2932,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_1 = 2933,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_2 = 2934,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_3 = 2935,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_4 = 2936,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_5 = 2937,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_6 = 2938,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_7 = 2939,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CAR_COLLISION_8 = 2940,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_EVENT_1 = 2941,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_EVENT_2 = 2942,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_EVENT_3 = 2943,
	AUDIO_SAMPLE_PED_WHITE_FAT_FEMALE_1_CHAT_EVENT_4 = 2944,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_1 = 2945,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_2 = 2946,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_3 = 2947,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_4 = 2948,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_EVADE_1 = 2949,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_EVADE_2 = 2950,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_EVADE_3 = 2951,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_JACKED_1 = 2952,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_JACKED_2 = 2953,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_ROBBED_1 = 2954,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_1 = 2955,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_2 = 2956,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_3 = 2957,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_4 = 2958,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_5 = 2959,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_6 = 2960,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_7 = 2961,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CAR_COLLISION_8 = 2962,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_EVENT_1 = 2963,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_CHAT_EVENT_2 = 2964,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_HANDS_COWER_1 = 2965,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_HANDS_COWER_2 = 2966,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_FLEE_RUN_1 = 2967,
	AUDIO_SAMPLE_PED_WHITE_CASUAL_FEMALE_1_FLEE_RUN_2 = 2968,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_1 = 2969,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_2 = 2970,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_3 = 2971,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_4 = 2972,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_5 = 2973,
	AUDIO_SAMPLE_PED_DIABLO_1_EVADE_1 = 2974,
	AUDIO_SAMPLE_PED_DIABLO_1_EVADE_2 = 2975,
	AUDIO_SAMPLE_PED_DIABLO_1_EVADE_3 = 2976,
	AUDIO_SAMPLE_PED_DIABLO_1_EVADE_4 = 2977,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_JACKED_1 = 2978,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_JACKED_2 = 2979,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_JACKING_1 = 2980,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_JACKING_2 = 2981,
	AUDIO_SAMPLE_PED_DIABLO_1_ATTACK_1 = 2982,
	AUDIO_SAMPLE_PED_DIABLO_1_ATTACK_2 = 2983,
	AUDIO_SAMPLE_PED_DIABLO_1_ATTACK_3 = 2984,
	AUDIO_SAMPLE_PED_DIABLO_1_ATTACK_4 = 2985,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_SEXY_1 = 2986,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_SEXY_2 = 2987,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_SEXY_3 = 2988,
	AUDIO_SAMPLE_PED_DIABLO_1_CHAT_SEXY_4 = 2989,
	AUDIO_SAMPLE_PED_DIABLO_1_HANDS_UP_1 = 2990,
	AUDIO_SAMPLE_PED_DIABLO_1_HANDS_UP_2 = 2991,
	AUDIO_SAMPLE_PED_DIABLO_1_HANDS_UP_3 = 2992,
	AUDIO_SAMPLE_PED_DIABLO_1_HANDS_UP_4 = 2993,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_COLLISION_1 = 2994,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_COLLISION_2 = 2995,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_COLLISION_3 = 2996,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_COLLISION_4 = 2997,
	AUDIO_SAMPLE_PED_DIABLO_1_CAR_COLLISION_5 = 2998,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_1 = 2999,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_2 = 3000,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_3 = 3001,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_4 = 3002,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_5 = 3003,
	AUDIO_SAMPLE_PED_DIABLO_2_EVADE_1 = 3004,
	AUDIO_SAMPLE_PED_DIABLO_2_EVADE_2 = 3005,
	AUDIO_SAMPLE_PED_DIABLO_2_EVADE_3 = 3006,
	AUDIO_SAMPLE_PED_DIABLO_2_EVADE_4 = 3007,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_JACKED_1 = 3008,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_JACKED_2 = 3009,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_JACKING_1 = 3010,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_JACKING_2 = 3011,
	AUDIO_SAMPLE_PED_DIABLO_2_ATTACK_1 = 3012,
	AUDIO_SAMPLE_PED_DIABLO_2_ATTACK_2 = 3013,
	AUDIO_SAMPLE_PED_DIABLO_2_ATTACK_3 = 3014,
	AUDIO_SAMPLE_PED_DIABLO_2_ATTACK_4 = 3015,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_SEXY_1 = 3016,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_SEXY_2 = 3017,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_SEXY_3 = 3018,
	AUDIO_SAMPLE_PED_DIABLO_2_CHAT_SEXY_4 = 3019,
	AUDIO_SAMPLE_PED_DIABLO_2_HANDS_UP_1 = 3020,
	AUDIO_SAMPLE_PED_DIABLO_2_HANDS_UP_2 = 3021,
	AUDIO_SAMPLE_PED_DIABLO_2_HANDS_UP_3 = 3022,
	AUDIO_SAMPLE_PED_DIABLO_2_HANDS_UP_4 = 3023,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_COLLISION_1 = 3024,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_COLLISION_2 = 3025,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_COLLISION_3 = 3026,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_COLLISION_4 = 3027,
	AUDIO_SAMPLE_PED_DIABLO_2_CAR_COLLISION_5 = 3028,
	AUDIO_SAMPLE_AMMUNATION_WELCOME_1 = 3029,
	AUDIO_SAMPLE_AMMUNATION_WELCOME_2 = 3030,
	AUDIO_SAMPLE_AMMUNATION_WELCOME_3 = 3031,
	TOTAL_AUDIO_SAMPLES = 3032,
	NO_SAMPLE = 3033,
	
	// shorthands
	SAMPLEBANK_START     = AUDIO_SAMPLE_VEHICLE_HORN_0,
	SAMPLEBANK_END       = AUDIO_SAMPLE_PAGER,
	SAMPLEBANK_MAX       = AUDIO_SAMPLE_PAGER+1,
	SAMPLEBANK_PED_START = AUDIO_SAMPLE_POLICE_COP_1_ARREST_1,
	SAMPLEBANK_PED_END   = AUDIO_SAMPLE_AMMUNATION_WELCOME_3,
	SAMPLEBANK_PED_MAX   = AUDIO_SAMPLE_AMMUNATION_WELCOME_3+1,
};

enum eScriptSounds : int16
{
  SCRIPT_SOUND_0 = 0,
  SCRIPT_SOUND_1 = 1,
  SCRIPT_SOUND_2 = 2,
  SCRIPT_SOUND_3 = 3,
  SCRIPT_SOUND_PARTY_1_LOOP_S = 4,
  SCRIPT_SOUND_PARTY_1_LOOP_L = 5,
  SCRIPT_SOUND_PARTY_2_LOOP_S = 6,
  SCRIPT_SOUND_PARTY_2_LOOP_L = 7,
  SCRIPT_SOUND_PARTY_3_LOOP_S = 8,
  SCRIPT_SOUND_PARTY_3_LOOP_L = 9,
  SCRIPT_SOUND_PARTY_4_LOOP_S = 10,
  SCRIPT_SOUND_PARTY_4_LOOP_L = 11,
  SCRIPT_SOUND_PARTY_5_LOOP_S = 12,
  SCRIPT_SOUND_PARTY_5_LOOP_L = 13,
  SCRIPT_SOUND_PARTY_6_LOOP_S = 14,
  SCRIPT_SOUND_PARTY_6_LOOP_L = 15,
  SCRIPT_SOUND_PARTY_7_LOOP_S = 16,
  SCRIPT_SOUND_PARTY_7_LOOP_L = 17,
  SCRIPT_SOUND_PARTY_8_LOOP_S = 18,
  SCRIPT_SOUND_PARTY_8_LOOP_L = 19,
  SCRIPT_SOUND_PARTY_9_LOOP_S = 20,
  SCRIPT_SOUND_PARTY_9_LOOP_L = 21,
  SCRIPT_SOUND_PARTY_10_LOOP_S = 22,
  SCRIPT_SOUND_PARTY_10_LOOP_L = 23,
  SCRIPT_SOUND_PARTY_11_LOOP_S = 24,
  SCRIPT_SOUND_PARTY_11_LOOP_L = 25,
  SCRIPT_SOUND_PARTY_12_LOOP_S = 26,
  SCRIPT_SOUND_PARTY_12_LOOP_L = 27,
  SCRIPT_SOUND_PARTY_13_LOOP_S = 28,
  SCRIPT_SOUND_PARTY_13_LOOP_L = 29,
  SCRIPT_SOUND_STRIP_CLUB_LOOP_1_S = 30,
  SCRIPT_SOUND_STRIP_CLUB_LOOP_1_L = 31,
  SCRIPT_SOUND_STRIP_CLUB_LOOP_2_S = 32,
  SCRIPT_SOUND_STRIP_CLUB_LOOP_2_L = 33,
  SCRIPT_SOUND_WORK_SHOP_LOOP_S = 34,
  SCRIPT_SOUND_WORK_SHOP_LOOP_L = 35,
  SCRIPT_SOUND_SAWMILL_LOOP_S = 36,
  SCRIPT_SOUND_SAWMILL_LOOP_L = 37,
  SCRIPT_SOUND_38 = 38,
  SCRIPT_SOUND_39 = 39,
  SCRIPT_SOUND_LAUNDERETTE_LOOP_S = 40,
  SCRIPT_SOUND_LAUNDERETTE_LOOP_L = 41,
  SCRIPT_SOUND_CHINATOWN_RESTAURANT_S = 42,
  SCRIPT_SOUND_CHINATOWN_RESTAURANT_L = 43,
  SCRIPT_SOUND_CIPRIANI_RESAURANT_S = 44,
  SCRIPT_SOUND_CIPRIANI_RESAURANT_L = 45,
  SCRIPT_SOUND_46 = 46,
  SCRIPT_SOUND_47 = 47,
  SCRIPT_SOUND_MARCO_BISTRO_S = 48,
  SCRIPT_SOUND_MARCO_BISTRO_L = 49,
  SCRIPT_SOUND_AIRPORT_LOOP_S = 50,
  SCRIPT_SOUND_AIRPORT_LOOP_L = 51,
  SCRIPT_SOUND_SHOP_LOOP_S = 52,
  SCRIPT_SOUND_SHOP_LOOP_L = 53,
  SCRIPT_SOUND_CINEMA_LOOP_S = 54,
  SCRIPT_SOUND_CINEMA_LOOP_L = 55,
  SCRIPT_SOUND_DOCKS_LOOP_S = 56,
  SCRIPT_SOUND_DOCKS_LOOP_L = 57,
  SCRIPT_SOUND_HOME_LOOP_S = 58,
  SCRIPT_SOUND_HOME_LOOP_L = 59,
  SCRIPT_SOUND_FRANKIE_PIANO = 60,
  SCRIPT_SOUND_PARTY_1_LOOP = 61,
  SCRIPT_SOUND_PORN_CINEMA_1_S = 62,
  SCRIPT_SOUND_PORN_CINEMA_1_L = 63,
  SCRIPT_SOUND_PORN_CINEMA_2_S = 64,
  SCRIPT_SOUND_PORN_CINEMA_2_L = 65,
  SCRIPT_SOUND_PORN_CINEMA_3_S = 66,
  SCRIPT_SOUND_PORN_CINEMA_3_L = 67,
  SCRIPT_SOUND_BANK_ALARM_LOOP_S = 68,
  SCRIPT_SOUND_BANK_ALARM_LOOP_L = 69,
  SCRIPT_SOUND_POLICE_BALL_LOOP_S = 70,
  SCRIPT_SOUND_POLICE_BALL_LOOP_L = 71,
  SCRIPT_SOUND_RAVE_LOOP_INDUSTRIAL_S = 72,
  SCRIPT_SOUND_RAVE_LOOP_INDUSTRIAL_L = 73,
  SCRIPT_SOUND_74 = 74,
  SCRIPT_SOUND_75 = 75,
  SCRIPT_SOUND_POLICE_CELL_BEATING_LOOP_S = 76,
  SCRIPT_SOUND_POLICE_CELL_BEATING_LOOP_L = 77,
  SCRIPT_SOUND_INJURED_PED_MALE_OUCH_S = 78,
  SCRIPT_SOUND_INJURED_PED_MALE_OUCH_L = 79,
  SCRIPT_SOUND_INJURED_PED_FEMALE_OUCH_S = 80,
  SCRIPT_SOUND_INJURED_PED_FEMALE_OUCH_L = 81,
  SCRIPT_SOUND_EVIDENCE_PICKUP = 82,
  SCRIPT_SOUND_UNLOAD_GOLD = 83,
  SCRIPT_SOUND_RAVE_1_LOOP_S = 84,
  SCRIPT_SOUND_RAVE_1_LOOP_L = 85,
  SCRIPT_SOUND_RAVE_2_LOOP_S = 86,
  SCRIPT_SOUND_RAVE_2_LOOP_L = 87,
  SCRIPT_SOUND_RAVE_3_LOOP_S = 88,
  SCRIPT_SOUND_RAVE_3_LOOP_L = 89,
  SCRIPT_SOUND_MISTY_SEX_S = 90,
  SCRIPT_SOUND_MISTY_SEX_L = 91,
  SCRIPT_SOUND_GATE_START_CLUNK = 92,
  SCRIPT_SOUND_GATE_STOP_CLUNK = 93,
  SCRIPT_SOUND_PART_MISSION_COMPLETE = 94,
  SCRIPT_SOUND_CHUNKY_RUN_SHOUT = 95,
  SCRIPT_SOUND_SECURITY_GUARD_AWAY_SHOUT = 96,
  SCRIPT_SOUND_RACE_START_3 = 97,
  SCRIPT_SOUND_RACE_START_2 = 98,
  SCRIPT_SOUND_RACE_START_1 = 99,
  SCRIPT_SOUND_RACE_START_GO = 100,
  SCRIPT_SOUND_SWAT_PED_SHOUT = 101,
  SCRIPT_SOUND_PRETEND_FIRE_LOOP = 102,
  SCRIPT_SOUND_AMMUNATION_CHAT_1 = 103,
  SCRIPT_SOUND_AMMUNATION_CHAT_2 = 104,
  SCRIPT_SOUND_AMMUNATION_CHAT_3 = 105,
  SCRIPT_SOUND_BULLET_HIT_GROUND_1 = 106,
  SCRIPT_SOUND_BULLET_HIT_GROUND_2 = 107,
  SCRIPT_SOUND_BULLET_HIT_GROUND_3 = 108,
  SCRIPT_SOUND_109 = 109,
  SCRIPT_SOUND_110 = 110,
  SCRIPT_SOUND_111 = 111,
  SCRIPT_SOUND_PAYPHONE_RINGING = 112,
  SCRIPT_SOUND_113 = 113,
  SCRIPT_SOUND_GLASS_BREAK_L = 114,
  SCRIPT_SOUND_GLASS_BREAK_S = 115,
  SCRIPT_SOUND_GLASS_CRACK = 116,
  SCRIPT_SOUND_GLASS_LIGHT_BREAK = 117,
  SCRIPT_SOUND_BOX_DESTROYED_1 = 118,
  SCRIPT_SOUND_BOX_DESTROYED_2 = 119,
  SCRIPT_SOUND_METAL_COLLISION = 120,
  SCRIPT_SOUND_TIRE_COLLISION = 121,
  SCRIPT_SOUND_GUNSHELL_DROP = 122,
  SCRIPT_SOUND_GUNSHELL_DROP_SOFT = 123,
};
